unit Browser;

interface

uses Forms, StdCtrls, Buttons, ExtCtrls, Tabs, Controls, Classes, WinTypes;

type
  TFormBrowse = class(TForm)
    NotebookPpte: TNotebook;
    TabSet: TTabSet;
    MemoChaine: TMemo;
    MemoHexa: TMemo;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    NotebookObj: TNotebook;
    ListBoxPpte: TListBox;
    Panel1: TPanel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    IdObj: TLabel;
    TypeObj: TLabel;
    FlagObj: TLabel;
    SecuObj: TEdit;
    TempsObj: TLabel;
    BlockObj: TLabel;
    DisqueObj: TLabel;
    Panel2: TPanel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    TabSetObj: TTabSet;
    NomPpte: TLabel;
    FlagsPpte: TLabel;
    SecuPpte: TLabel;
    Panel3: TPanel;
    DeletePasswd: TBitBtn;
    ChangePasswd: TBitBtn;
    VerifPasswd: TBitBtn;
    CreerPpte: TBitBtn;
    Bevel1: TBevel;
    DeletePpte: TBitBtn;
    NomObj: TEdit;
    DeleteObj: TBitBtn;
    NotebookBind: TNotebook;
    TabSetBind: TTabSet;
    Panel4: TPanel;
    RefreshObj: TBitBtn;
    CreeObj: TBitBtn;
    ListBoxObj: TListBox;
    procedure FormCreate(Sender: TObject);
    procedure TabSetChange(Sender: TObject; NewTab: Integer;var AllowChange: Boolean);
    procedure ListBoxObjClick(Sender: TObject);
    procedure ListBoxPpteClick(Sender: TObject);
    procedure RefreshObjClick(Sender: TObject);
    procedure ListBoxObjDrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
    procedure NomObjExit(Sender: TObject);
    procedure SecuObjExit(Sender: TObject);
    procedure TabSetObjChange(Sender: TObject; NewTab: Integer;
      var AllowChange: Boolean);
    procedure VerifPasswdClick(Sender: TObject);
    procedure ChangePasswdClick(Sender: TObject);
    procedure DeletePasswdClick(Sender: TObject);
    procedure CreerPpteClick(Sender: TObject);
    procedure DeletePpteClick(Sender: TObject);
    procedure TabSetBindChange(Sender: TObject; NewTab: Integer;
      var AllowChange: Boolean);
    procedure CreeObjClick(Sender: TObject);
    procedure DeleteObjClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private-dclarations }
  public
    { Public-dclarations }
  end;

var
  FormBrowse: TFormBrowse;

implementation

{$R *.DFM}

uses SysUtils, Dialogs,
        Principa, Boite3, Boite7, Boite8, Boite9,
        TNWBind, TNWObj, TNWPpte;

procedure TFormBrowse.FormCreate(Sender: TObject);
begin
    TabSet.Tabs := NoteBookPpte.Pages;
    TabSetObj.Tabs := NoteBookObj.Pages;
    TabSetBind.Tabs := NoteBookBind.Pages;
end;

procedure TFormBrowse.FormShow(Sender: TObject);
begin
    Patientez.Show;
    Patientez.Update;
    Bindery.ChercheObjects(ListBoxObj.Items, '*', $FFFF);
    Patientez.Hide;
end;

procedure TFormBrowse.TabSetChange(Sender: TObject; NewTab: Integer; var AllowChange: Boolean);
begin
    NoteBookPpte.PageIndex := NewTab;
end;

procedure TFormBrowse.TabSetObjChange(Sender: TObject; NewTab: Integer; var AllowChange: Boolean);
begin
    NoteBookObj.PageIndex := NewTab;
end;

procedure TFormBrowse.TabSetBindChange(Sender: TObject; NewTab: Integer; var AllowChange: Boolean);
begin
    NoteBookBind.PageIndex := NewTab;
end;


procedure TFormBrowse.ListBoxObjClick(Sender: TObject);
var Obj: TNWObject;
begin
    if (ListBoxObj.ItemIndex = -1) then exit;
    Obj := TNWObject(ListBoxObj.Items.Objects[ListBoxObj.ItemIndex]);
    IDObj.Caption := IntToHex(Obj.ObjID, 8);
    NomObj.Text := Obj.ObjNom;
    TypeObj.Caption := IntToStr(Obj.ObjType);
    FlagObj.Caption := IntToStr(Obj.ObjFlags);
    SecuObj.Text := IntToStr(Obj.ObjSecurite);
    TempsObj.Caption := IntToStr(Obj.ObjTempsConnexion);
    BlockObj.Caption := IntToStr(Obj.ObjNbBlockAlloue);
    DisqueObj.Caption := IntToStr(Obj.ObjRestrictionDisk);
    Patientez.Show;
    Patientez.Update;
    Obj.CherchePropriete(ListBoxPpte.Items, '*');
    Patientez.Hide;
end;


procedure TFormBrowse.ListBoxPpteClick(Sender: TObject);
var Ppte: TNWPropriete;
    Compteur1, Compteur2: Integer;
    NewVal: String;
    Ajout: String;
begin
    if (ListBoxObj.ItemIndex = -1) then exit;
    Ppte := TNWPropriete(ListBoxPpte.Items.Objects[ListBoxPpte.ItemIndex]);
    NomPpte.Caption := Ppte.PpteNom;
    FlagsPpte.Caption := IntToHex(Ppte.PpteFlags, 2);
    SecuPpte.Caption := IntToHex(Ppte.PpteSecurite, 2);
    MemoChaine.Lines.Clear;
    MemoHexa.Lines.Clear;
    Compteur1 := 1;
    while Ppte.PpteValeurs[Compteur1] <> '' do
    begin
        NewVal := Ppte.PpteValeurs[Compteur1];
        Ajout := '';
        for Compteur2 := 1 to 128 do Ajout := Ajout + IntToHex(Byte(NewVal[Compteur2]), 2);
        MemoHexa.Lines.Add(Ajout);
        for Compteur2 := 1 to 128 do if (NewVal[Compteur2] < Chr(30)) then NewVal[Compteur2] := '_';
        MemoChaine.Lines.Add(NewVal);
        Inc(Compteur1);
    end;
end;

procedure TFormBrowse.RefreshObjClick(Sender: TObject);
begin
    Patientez.Show;
    Patientez.Update;
    Bindery.ChercheObjects(ListBoxObj.Items, '*', $FFFF);
    Patientez.Hide;
end;

procedure TFormBrowse.ListBoxObjDrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
begin
    FormPrincipale.DrawItem(Control, Index, Rect, State);
end;

procedure TFormBrowse.NomObjExit(Sender: TObject);
var Obj: TNWObject;
begin
    if (ListBoxObj.ItemIndex = -1) then exit;
    Obj := TNWObject(ListBoxObj.Items.Objects[ListBoxObj.ItemIndex]);
    Obj.ObjNom := NomObj.Text;
    Bindery.ChercheObjects(ListBoxObj.Items, '*', $FFFF);
end;

procedure TFormBrowse.SecuObjExit(Sender: TObject);
var Obj: TNWObject;
    Secu: Byte;
begin
    if (ListBoxObj.ItemIndex = -1) then exit;
    try
        Secu := StrToInt(SecuObj.Text);
    except
        MessageDlg('La securit est un BYTE !', mtError, [mbOK], 0);
        SecuObj.SetFocus;
    end;
    Obj := TNWObject(ListBoxObj.Items.Objects[ListBoxObj.ItemIndex]);
    Obj.ObjSecurite := Secu;
end;


procedure TFormBrowse.VerifPasswdClick(Sender: TObject);
var Obj: TNWObject;
begin
    if (ListBoxObj.ItemIndex = -1) then exit;
    FormPassword.Password.Text := '';
    FormPassword.Caption := 'Verifier le mot de passe';
    if (FormPassword.ShowModal = mrOK) then
    begin
        Obj := TNWObject(ListBoxObj.Items.Objects[ListBoxObj.ItemIndex]);
        if (Obj.VerifieMotDePasse(FormPassword.Password.Text) = 0) then
            MessageDlg('Mot de passe correct', mtInformation, [mbOK], 0)
        else
            MessageDlg('Mot de passe errone', mtError, [mbOK], 0);
    end;
end;

procedure TFormBrowse.ChangePasswdClick(Sender: TObject);
var Obj: TNWObject;
    OldPassword: String;
begin
    if (ListBoxObj.ItemIndex = -1) then exit;
    OldPassword := '';
    FormPassword.Password.Text := '';
    FormPassword.Caption := 'Entrer l''ancien mot de passe';
    if (FormPassword.ShowModal = mrOK) then
    begin
        OldPassword := FormPassword.Password.Text;
        FormPassword.Password.Text := '';
        FormPassword.Caption := 'Entrer le noveau mot de passe';
        if (FormPassword.ShowModal = mrOK) then
        begin
            Obj := TNWObject(ListBoxObj.Items.Objects[ListBoxObj.ItemIndex]);
            if (Obj.ChangeMotDePasse(OldPassword, FormPassword.Password.Text) = 0) then
                MessageDlg('Mot de passe change', mtInformation, [mbOK], 0)
            else
                MessageDlg('Mot de passe non change', mtError, [mbOK], 0);
        end;
    end;
end;

procedure TFormBrowse.DeletePasswdClick(Sender: TObject);
var Obj: TNWObject;
begin
    if (ListBoxObj.ItemIndex = -1) then exit;
    FormPassword.Password.Text := '';
    FormPassword.Caption := 'Enlever le mot de passe';
    if (FormPassword.ShowModal = mrOK) then
    begin
        Obj := TNWObject(ListBoxObj.Items.Objects[ListBoxObj.ItemIndex]);
        if (Obj.DesactiveMotDePasse(FormPassword.Password.Text) = 0) then
            MessageDlg('Mot de passe enleve', mtInformation, [mbOK], 0)
        else
            MessageDlg('Mot de passe non enleve', mtError, [mbOK], 0);
    end;
end;

procedure TFormBrowse.CreerPpteClick(Sender: TObject);
var Obj: TNWObject;
    Flags, Secu: Byte;
begin
    if (ListBoxObj.ItemIndex = -1) then exit;
    if (FormCreatePpte.ShowModal = mrOk) then
    begin
        try
            Flags := StrToInt(FormCreatePpte.PpteFlags.Text);
        except
            MessageDlg('Flags doit etre un byte', mtError, [mbOK], 0);
            Exit;
        end;
        try
            Secu := StrToInt(FormCreatePpte.PpteSecu.Text);
        except
            MessageDlg('Securite doit etre un byte', mtError, [mbOK], 0);
            Exit;
        end;
        Obj := TNWObject(ListBoxObj.Items.Objects[ListBoxObj.ItemIndex]);
        if (Obj.CreerPropriete(FormCreatePpte.PpteNom.Text, Flags, Secu) = 0) then
        begin
            MessageDlg('Propriete cree', mtInformation, [mbOK], 0);
            Patientez.Show;
            Patientez.Update;
            Obj.CherchePropriete(ListBoxPpte.Items, '*');
            Patientez.Hide;
        end
        else
            MessageDlg('Propriete non cree', mtError, [mbOK], 0);
    end;
end;

procedure TFormBrowse.DeletePpteClick(Sender: TObject);
var Ppte: TNWPropriete;
    Obj: TNWObject;
begin
    if (ListBoxPpte.ItemIndex = -1) then Exit;
    if (ListBoxObj.ItemIndex = -1) then Exit;
    Ppte := TNWPropriete(ListBoxPpte.Items.Objects[ListBoxPpte.ItemIndex]);
    if (Ppte.Delete = 0) then
    begin
        MessageDlg('Proprit Enleve', mtInformation, [mbOK], 0);
        Obj := TNWObject(ListBoxObj.Items.Objects[ListBoxObj.ItemIndex]);
        Patientez.Show;
        Patientez.Update;
        Obj.CherchePropriete(ListBoxPpte.Items, '*');
        Patientez.Hide;
    end
    else
        MessageDlg('Propritt non enleve', mtError, [mbOK], 0);
end;


procedure TFormBrowse.CreeObjClick(Sender: TObject);
var ObjType: Word;
    ObjFlags, ObjSecu: Byte;
begin
    if (FormCreateObj.ShowModal = mrOk) then
    begin
        try
            ObjType := StrToInt(FormCreateObj.ObjType.Text);
        except
            MessageDlg('Type doit etre un word', mtError, [mbOK], 0);
            Exit;
        end;
        try
            ObjFlags := StrToInt(FormCreateObj.ObjFlags.Text);
        except
            MessageDlg('Flags doit etre un byte', mtError, [mbOK], 0);
            Exit;
        end;
        try
            ObjSecu := StrToInt(FormCreateObj.ObjSecu.Text);
        except
            MessageDlg('Securite doit etre un byte', mtError, [mbOK], 0);
            Exit;
        end;

        if (Bindery.CreerObject(FormCreateObj.ObjNom.Text, ObjType, ObjFlags, ObjSecu) = 0) then
        begin
            MessageDlg('Objet cree', mtInformation, [mbOK], 0);
            Patientez.Show;
            Patientez.Update;
            Bindery.ChercheObjects(ListBoxObj.Items, '*', $FFFF);
            Patientez.Hide;
        end
        else
            MessageDlg('Objet non cree', mtError, [mbOK], 0);
    end;
end;

procedure TFormBrowse.DeleteObjClick(Sender: TObject);
var Obj: TNWObject;
begin
    if (ListBoxObj.ItemIndex = -1) then Exit;
    Obj := TNWObject(ListBoxObj.Items.Objects[ListBoxObj.ItemIndex]);
    if (Obj.Delete = 0) then
    begin
        MessageDlg('Objet Enlev', mtInformation, [mbOK], 0);
        Patientez.Show;
        Patientez.Update;
        Bindery.ChercheObjects(ListBoxObj.Items, '*', $FFFF);
        Patientez.Hide;
    end
    else
        MessageDlg('Objet non enlev', mtError, [mbOK], 0);
end;




end.
