unit Nwfs;

interface

uses
  TCalls, NwCalls, TIPXSPX, TTLI, NWTLI, NwIPXSPX, TNet, NWNet, NWTypes, NWConst,NWConst2,
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls,Grids, Outline, NWconn;


const FA_NORMAL =	      $00;
const FA_READ_ONLY =	   $01;
const FA_HIDDEN =	      $02;
const FA_SYSTEM =	      $04;
const FA_EXECUTE_ONLY =   $08;
const FA_DIRECTORY =	   $10;
const FA_NEEDS_ARCHIVED =	$20;
const FA_SHAREABLE =	   $80;

type
  TNWVolume = class;
  TNWDirectory = class;

{*********************************************}
{*             Class TNWInfoFile             *}
{*********************************************}
TNWInfoFile  = class
private
  { Dclarations private }
  FName: String;
  FAllPath: String;
  FileAttributes: byte;
  FileMode: byte;
  FileLength: longint;
  CreateDate: word;
  AccesDate: word;
  UpdateDate: word;
  UpdateTime: word;
  FConn: TNWConn;
  {*** Fonctions ***}
  function  GetFAReadOnly       :boolean;
  procedure SetFAReadOnly       (val: boolean);
  function  GetFAHidden         :boolean;
  procedure SetFAHidden         (val: boolean);
  function  GetFASystem         :boolean;
  procedure SetFASystem         (val: boolean);
  function  GetFAExecuteOnly    :boolean;
  procedure SetFAExecuteOnly    (val: boolean);
  function  GetFAShareable      :boolean;
  procedure SetFAShareable      (val: boolean);
  function  GetFMOpenForRead          :boolean;
  function  GetFMOpenForWrite          :boolean;
  function  GetFMDenyReadFromOthers   :boolean;
  function  GetFMDenyWriteFromOthers  :boolean;
  function  GetFMFileDetach           :boolean;
  function  GetFMTTSHoldingDetach     :boolean;
  function  GetFMTTSHoldingOpen       :boolean;
  function  GetJour    :word;
  function  GetMois    :word;
  function  GetAnnee   :word;
  function  GetHeure   :word;
  function  GetMinute  :word;
  function  GetSeconde :word;
  procedure WriteAttr (mot: byte; flag: byte; val: boolean);
  function  ModifyAttribute(Name: String;attr: byte): word;

public
  { Dclarations public }
  {*** File Attributes ***}
  property FAReadOnly: Boolean read GetFAReadOnly write SetFAReadOnly;
  property FAHidden: Boolean read GetFAHidden write SetFAHidden;
  property FASystem: Boolean read GetFASystem write SetFASystem;
  property FAExecuteOnly: Boolean read GetFAExecuteOnly write SetFAExecuteOnly;
  property FAShareable: Boolean read GetFAShareable write SetFAShareable;
  {*** File Mode ***}
  property FMOpenForRead: Boolean read GetFMOpenForRead;
  property FMOpenForWrite: Boolean read GetFMOpenForWrite;
  property FMDenyReadFromOthers: Boolean read GetFMDenyReadFromOthers;
  property FMDenyWriteFromOthers: Boolean read GetFMDenyWriteFromOthers;
  property FMFileDetach: Boolean read GetFMFileDetach;
  property FMTTSHoldingDetach: Boolean read GetFMTTSHoldingDetach;
  property FMTTSHoldingOpen: Boolean read GetFMTTSHoldingOpen;
  {*** Date and Time (seulement en lecture) ***}
  property Jour : word read GetJour;
  property Mois : word read GetMois;
  property Annee : word read GetAnnee;
  property Heure : word read GetHeure;
  property Minute : word read GetMinute;
  property Seconde : word read GetSeconde;
  {*** Other ***}
  property taille: longint read FileLength;
  property FileName: String read FName;
  property AllPath: String read FAllPath;
  {*** Fonction ***}
  constructor Create (nom: String;info: SEARCH_FILE_INFO;Connection: TNWConn);
end;

{*********************************************}
{*             Class TNWInfoDirectory            *}
{*********************************************}
TNWInfoDirectory = class
private
  { Dclarations private }
  FName: String;
  FAllPath: String;
  Fproprietaire: String;
  DirectoryAttributes: byte;
  DirectoryAccessRights: byte;
  CreateDate: word;
  CreateTime: word;
  owningObjectID: longint;
  DirectoryStamp: word;
  FConn: TNWConn;
  {*** Fonctions ***}
  function  GetDAHidden      :boolean;
  procedure SetDAHidden      (val: boolean);
  function  GetDASystem      :boolean;
  procedure SetDASystem      (val: boolean);
  function  GetDRRead        :boolean;
  procedure SetDRRead        (val: boolean);
  function  GetDRWrite       :boolean;
  procedure SetDRWrite       (val: boolean);
  function  GetDROpen        :boolean;
  procedure SetDROpen        (val: boolean);
  function  GetDRCreate      :boolean;
  procedure SetDRCreate      (val: boolean);
  function  GetDRDelete      :boolean;
  procedure SetDRDelete      (val: boolean);
  function  GetDROwnership   :boolean;
  procedure SetDROwnership   (val: boolean);
  function  GetDRSearch      :boolean;
  procedure SetDRSearch      (val: boolean);
  function  GetDRModify      :boolean;
  procedure SetDRModify      (val: boolean);
  function  GetJour    :word;
  function  GetMois    :word;
  function  GetAnnee   :word;
  function  GetHeure   :word;
  function  GetMinute  :word;
  function  GetSeconde :word;
  function  GetProprietaire :String;
  procedure SetProprietaire (nom: String);
  procedure WriteAttr (mot: byte; flag: byte; val: boolean);
  function  ModifyAttribute(Name: String;attr: byte): word;
  function  ModifyDirectory (name: String;date: word; time: word;owner: longint;right :byte): word;
  procedure WriteRight (mot: byte; flag: byte; val: boolean);
public
  { Dclarations public }
  {*** Directory Attributes ***}
  property DAHidden: Boolean read GetDAHidden write SetDAHidden;
  property DASystem: Boolean read GetDASystem write SetDASystem;
  {*** Directory Right ***}
  property DRRead : Boolean read GetDRRead write SetDRRead;
  property DRWrite : Boolean read GetDRWrite write SetDRWrite;
  property DROpen : Boolean read GetDROpen write SetDROpen;
  property DRCreate : Boolean read GetDRCreate write SetDRCreate;
  property DRDelete : Boolean read GetDRDelete write SetDRDelete;
  property DROwnership : Boolean read GetDROwnership write SetDROwnership;
  property DRSearch : Boolean read GetDRSearch write SetDRSearch;
  property DRModify : Boolean read GetDRModify write SetDRModify;
  {*** Date and Time (seulement en lecture) ***}
  property Jour : word read GetJour;
  property Mois : word read GetMois;
  property Annee : word read GetAnnee;
  property Heure : word read GetHeure;
  property Minute : word read GetMinute;
  property Seconde : word read GetSeconde;
  {*** Other ***}
  property DirectoryName: String read FName;
  property AllPath: String read FAllPath;
  property Proprietaire: String read GetProprietaire write SetProprietaire;

  constructor Create (nom: String;info: SEARCH_DIR_INFO;Connection: TNWConn);
end;

{*********************************************}
{*             Class TNWFile                 *}
{*********************************************}
TNWFile = class(TListBox)
  private
    { Dclarations private }
    FDirectory: TNWDirectory;
    Image_FILE: TBitmap;
    Image_DIR: TBitmap;
    Image_EXEFILE: TBitmap;
    ListObj: TList;
    procedure SetDirectory (dir: TNWdirectory);
    procedure Scan (path: String;mode: byte);
    procedure LoadImage;
    procedure FreeImage;
    function GetPath :String;
    function GetFichier :String;
    function GetFileObject: TNWInfoFile;
    procedure SetFileObject(Fo: TNWInfoFile);
    function GetDirObject: TNWInfoDirectory;
    procedure SetDirObject(Fo: TNWInfoDirectory);
    function GetType: String;
    procedure ObjectDestroy;
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;
  protected
    { Dclarations protected }
    procedure DrawItem(Index: Integer;Rect: TRect; State: TOwnerDrawState); override;
    procedure DblClick; override;  {Redefinition de ON_DblClick}
  public
    { Dclarations public }
    constructor Create (Aowner: Tcomponent); override;
    destructor Destroy; override;
    property directory: TNWDirectory read FDirectory write SetDirectory;
    procedure BidString(toto : String);
    function GetAllPath: String;
    procedure Refresh;
  published
    { Dclarations published }
    property AllPath: String read GetAllPath write BidString;
    property Path: String read GetPath write BidString;
    property Fichier: String read GetFichier write BidString;
    property FileObject: TNWInfoFile  read GetFileObject write SetFileObject;
    property DirObject: TNWInfoDirectory  read GetDirObject write SetDirObject;
    property TypeObject: String read GetType write BidString;
  end;


{*********************************************}
{*             Class TNWDirectory            *}
{*********************************************}
  TNWDirectory = class(TOutline)
  private
    { Dclarations private }
    FVolume: TNWVolume;      {Disque}
    FHandle: word;
    FFichier: TNWFile;     {Fichier}
    procedure SetFichier (Fich: TNWFile);
    procedure SetVolume (Vol: TNWVolume);
    function GetAllPath : String;
    procedure BidString (toto: String);
    procedure Etendre (pere: longint; chemin: String);
    procedure Reduire (pere: longint);
    function GetPath: String;
    function GetDirectory: String;
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;
  protected
    { Dclarations protected }
    procedure Click; override;  {Redefinition de ON_Click}
    procedure DblClick; override;  {Redefinition de ON_DblClick}
    function Find (path: String): longint;
  public
    { Dclarations public }
    constructor Create (Aowner: Tcomponent); override;
    destructor Destroy; override;
    property Volume: TNWVolume read FVolume write SetVolume;
    procedure Expand(path: String);
    procedure Refresh;
  published
    { Dclarations published }
    property  Fichier: TNWFile read FFichier write SetFichier;
    property AllPath: String read GetAllPath write BidString;
    property Path: String read GetPath write BidString;
    property Directory: String read GetDirectory write BidString;
  end;

{*********************************************}
{*             Class TNWVolume               *}
{*********************************************}
  TNWVolume = class(TComboBox)
  private
    { Dclarations private }
    FConn: TNWConn;
    FDirectory: TNWDirectory;
    Image_NETWORK: TBitmap;
    procedure SetConnection (conn: TNWConn);
    procedure Scan;
    procedure BidString (toto: String);
    function GetVolume :String;
    procedure SetDirectory(dir: TNWDirectory);
    procedure LoadImage;
    procedure FreeImage;
    procedure DrawItem(Index: Integer;Rect: TRect; State: TOwnerDrawState); override;
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;
  protected
    { Dclarations protected }
    procedure Change; override;  {Redefinition de ON_Change}
  public
    { Dclarations public }
    constructor Create (Aowner: Tcomponent); override;
    destructor Destroy; override;
  published
    { Dclarations published }
    property Connection: TNWConn read FConn write SetConnection;
    property volume: String read GetVolume write BidString;
    property directory: TNWDirectory read FDirectory write SetDirectory;
  end;

{*********************************************}
{*             Class TNWFileSystem           *}
{*********************************************}
  TNWFileSystem = class(TComponent)
  private
    { Dclarations private }
    Fconn: TNWConn;
  protected
    { Dclarations protected }
    constructor Create (Aowner: Tcomponent); override;
    destructor Destroy; override;
  public
    { Dclarations public }
    function DeleteDirectory (name: String): word;
    function EraseFile (name: String): word;
    function CreateDirectory (name: String): word;
    function RenameDirectory (OldName: String;NewName: String): word;
    function RenameFile (OldName: String;NewName: String): word;
  published
    { Dclarations published }
    property Connection: TNWConn read FConn write Fconn;
  end;

procedure Register;

implementation

{$R NWfs2}

procedure Register;
begin
  RegisterComponents('Projet Novell', [TNWVolume,TNWDirectory,TNWFile,TNWFileSystem]);
end;

{*********************************************}
{*             Autres Procedures             *}
{*********************************************}
procedure DrawList(Sender: TWinControl;Index: Integer;
                   Rect: TRect; State: TOwnerDrawState;Image: TBitmap);
var
    Buffer: array[0..255] of Char;
begin
  if Sender is TcomboBox then
    with (Sender as TcomboBox) do
    begin
        Canvas.FillRect(Rect);
        Canvas.BrushCopy(Bounds(Rect.Left + 2,
                (Rect.Top + Rect.Bottom - Image.Height) div 2,
                Image.Width, Image.Height),
                Image, Bounds(0, 0, Image.Width, Image.Height),
                Image.Canvas.Pixels[0, Image.Height - 1]);
        StrPCopy(Buffer, Items[Index]);
        Rect.Left := Rect.Left + Image.Width + 6;
        DrawText(Canvas.Handle, Buffer, StrLen(Buffer), Rect, DT_SINGLELINE or DT_VCENTER or DT_NOPREFIX);
    end
  else
  if (sender is TListBox) then
     with (sender as TListBox) do
    begin
        Canvas.FillRect(Rect);
        Canvas.BrushCopy(Bounds(Rect.Left + 2,
                (Rect.Top + Rect.Bottom - Image.Height) div 2,
                Image.Width, Image.Height),
                Image, Bounds(0, 0, Image.Width, Image.Height),
                Image.Canvas.Pixels[0, Image.Height - 1]);
        StrPCopy(Buffer, Items[Index]);
        Rect.Left := Rect.Left + Image.Width + 6;
        DrawText(Canvas.Handle, Buffer, StrLen(Buffer), Rect, DT_SINGLELINE or DT_VCENTER or DT_NOPREFIX);
    end;
end;
{*** Decode un mot avec un mask de bit ***}
  function Decode (mot: byte; flag:byte) :Boolean;
  begin
     if (mot and flag)<>0 then
       result:=True
     else
       result:=False;
  end;

{*********************************************}
{*             Class TNWInfoFile             *}
{*********************************************}
constructor TNWInfoFile.Create(nom: String;info: SEARCH_FILE_INFO;Connection: TNWConn);
begin
  FileAttributes:=info.FileAttributes;
  FileMode:=info.FileMode;
  FileLength:=info.FileLenght;
  CreateDate:=info.CreateDate;
  AccesDate:=info.AccesDate;
  UpdateDate:=info.UpdateDate;
  UpdateTime:=info.UpdateTime;
  FConn:=Connection;
  FAllPath:=nom;
end;

{*********************************************}
{*             Class TNWInfoDirectoy         *}
{*********************************************}
constructor TNWInfoDirectory.Create (nom:String;info: SEARCH_DIR_INFO;Connection: TNWConn);
begin
  DirectoryAttributes:=info.DirectoryAttributes;
  DirectoryAccessRights:=info.DirectoryAccessRights;
  CreateDate:=info.CreateDate;
  CreateTime:=info.CreateTime;
  owningObjectID:=info.owningObjectID;
  DirectoryStamp:=info.DirectoryStamp;
  FConn:=Connection;
  FAllPath:=nom;
end;

{*********************************************}
{*             Class TNWVolume               *}
{*********************************************}
constructor TNWVolume.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  Fconn:=nil;
  FDirectory:=nil;
  Style:=csOwnerDrawFixed;
  LoadImage;
end;

destructor TNWVolume.Destroy;
begin
   FreeImage;
  inherited Destroy;
end;

procedure TNWVolume.Notification(AComponent: TComponent;Operation: TOperation);
begin
  inherited Notification(AComponent, Operation);
  if (Operation = opRemove) and (AComponent = FConn) then
    FConn := nil;
  if (Operation = opRemove) and (AComponent = FDirectory) then
    FDirectory:=nil;
end;

procedure TNWVolume.LoadImage;
begin
  if Image_NETWORK=nil then
  begin
     Image_NETWORK:=TBitmap.Create;
     Image_NETWORK.Handle :=LoadBitmap(HInstance, 'NW_NETWORK');
  end;
end;

procedure TNWVolume.FreeImage;
begin
  if Image_NETWORK<>nil then
     Image_NETWORK.Destroy;
end;

procedure TNWVolume.BidString (toto: String);
begin
  {C'est bidon}
end;

procedure TNWVolume.SetDirectory(dir: TNWDirectory);
begin
  if (FDirectory<>nil) and (dir<>nil) then dir.Volume:=nil;
  FDirectory:=dir;
  if FDirectory<>nil then dir.Volume:=Self;
end;

procedure TNWVolume.Change;
begin
  inherited Change;
  if (FDirectory <> Nil) then FDirectory.Volume:=Self;
end;

procedure TNWVolume.Scan;
  var
  ccode: NWCCODE;
  i: integer;
  name: array[0..100] of char;
begin
  Items.clear;
  text:='';
  if (Fconn<>nil) and (Fconn.Handle<>0) then
  begin
  i:=0;
  repeat
     ccode:=NWGetVolumeName (FConn.Handle,i,name);
     if ccode <> 0 then exit;

     if Name[0]<>char($0) then
        Items.add(StrPas (Name));
     i:=i+1;
  until (Name[0]=char($0));
  ItemIndex:=0;
  end;

end;

function TNWVolume.GetVolume :String;
begin
  if Text='' then
     result:=''
  else
     result:=text+':';
end;

procedure TNWVolume.SetConnection (conn: TNWConn);
begin
  Fconn:=conn;
  if (Fconn<>nil) and (Fconn.Handle<>0) then
     Scan;
  if FDirectory<>nil then FDirectory.Volume:=Self;
end;

procedure TNWVolume.DrawItem(Index: Integer; Rect: TRect; State: TOwnerDrawState);
begin
     DrawList(self,index,rect,State,Image_NETWORK);
end;



{*********************************************}
{*             Class TNWDirectory            *}
{*********************************************}
constructor TNWDirectory.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FFichier:=nil;
  FVolume:=nil;
  PictureLeaf:=PictureClosed;
end;

destructor TNWDirectory.Destroy;
begin
  inherited Destroy;
end;

procedure TNWDirectory.Notification(AComponent: TComponent;Operation: TOperation);
begin
  inherited Notification(AComponent, Operation);
  if (Operation = opRemove) and (AComponent = FFichier) then
    FFichier:=nil;
  if (Operation = opRemove) and (AComponent = FVolume) then
    FVolume:=nil;
end;

procedure TNWDirectory.BidString (toto: String);
begin
  {C'est bidon}
end;

procedure TNWDirectory.SetVolume (vol: TNWVolume);
begin
  FVolume:=vol;
  Clear;
  if (FVolume<>nil) and
     (FVolume.Connection<>nil) and
     (FVolume.Connection.Handle<>0) then
     AddChild (0,FVolume.Volume);
  if (FFichier <> Nil) then FFichier.Directory:=Self;
end;

function TNWDirectory.GetAllPath :String;
begin
  if (SelectedItem<>0) then
     result:=Items[SelectedItem].FullPath
  else
     result:='';
end;

procedure TNWDirectory.DblClick;
begin
  if (SelectedItem<>0) and (Items[SelectedItem].expanded = False) then
  begin
     etendre (SelectedItem,GetAllPath);
     inherited DblClick;
  end
  else
  begin
     inherited DblClick;
     reduire (SelectedItem);
  end;
end;

procedure TNWDirectory.Click;
begin
  inherited Click;
  if (FFichier <> Nil) then FFichier.Directory:=Self;
end;

procedure TNWdirectory.Etendre (pere: longint; chemin: string);
var
  volNum: byte;
  dirid: word;
  iter: word;
  acces: byte;
  ccode: word;
  info: SEARCH_INFO;
  buf: array [0..255] of char;
  buf2: array [0..255] of char;
  InfoDir: TNWInfoDirectory;
  InfoFile: TNWInfoFile;
begin

  if (FVolume<>nil) and
     (FVolume.Connection<>nil) and
     (FVolume.Connection.Handle<>0) then
  begin
     BeginUpdate;
     StrPcopy(buf,chemin);
     iter := $ffff;
     ccode:=NWintFileSearchInitialize(FVolume.Connection.Handle,
                                0,
                                @buf[0],
                                @VolNum,
                                @DirID,
                                @Iter,
                                @Acces,
                                0);
     repeat
        ccode:=NWintFileSearchContinue(FVolume.Connection.Handle,
                                volNum,
                                dirID,
                                iter,
                                $FF,
                                '*',
                                @info,
                                0);
        if (ccode=0) then
        begin
              AddChild (pere,StrPas(info.Dir.DirectoryName));
        end;
        iter:=info.fich.SequenceNumber;
     until ccode <>0;
     EndUpdate;
  end;
end;

procedure TNWDirectory.reduire (pere: longint);
var
  cur: longint;
begin
  BeginUpdate;
  cur := Items[pere].GetFirstChild;
  while (cur <>-1) do
  begin
     delete (cur);
     cur:=Items[pere].GetFirstChild;
  end;
  EndUpdate;
end;

procedure TNWDirectory.SetFichier (fich: TNWFile);
begin
  if (FFichier <> Nil) and (fich=nil) then FFichier.Directory:=Nil;
  FFichier:=fich;
  if fich<>nil then fich.Directory:=Self;
end;

function TNWDirectory.Find (path: String): longint;
var
  i: longint;
begin
  i:=1;
  result:=-1;
  for i:=1 to ItemCount do
     if Items[i].FullPath= path then
     begin
        result:=i;
        break;
     end;
end;

function TNWDirectory.GetPath: String;
begin
  if (SelectedItem<>0) and (Items[SelectedItem].parent.Index<>0) then
     result:=Items[Items[SelectedItem].parent.Index].FullPath
  else
     result:='';
end;

function TNWDirectory.GetDirectory: String;
begin
  if SelectedItem<>0 then
     result:=Items[SelectedItem].text
  else
     result:='';
end;

procedure TNWDirectory.expand(path: String);
var
  i: longint;
begin
  i:=Find(path);
  if i=-1 then DblClick;
  i:=Find(path);
  SelectedItem:=i;
end;

procedure TNWDirectory.Refresh;
var
  volNum: byte;
  dirid: word;
  iter: word;
  acces: byte;
  ccode: word;
  info: SEARCH_INFO;
  buf: array [0..255] of char;
  buf2: array [0..255] of char;
  InfoDir: TNWInfoDirectory;
  InfoFile: TNWInfoFile;
  i: longint;
begin

  if (FVolume<>nil) and
     (FVolume.Connection<>nil) and
     (FVolume.Connection.Handle<>0) and
     (ItemCount>1) then
  begin
     {On efface tous les fichiers qui n'existent plus}
     for i:=2 to ItemCount do
     begin
        iter := $ffff;
        StrPcopy(buf,Items[Items[i].parent.Index].FullPath);
        ccode:=NWintFileSearchInitialize(FVolume.Connection.Handle,
                                0,
                                @buf[0],
                                @VolNum,
                                @DirID,
                                @Iter,
                                @Acces,
                                0);
           ccode:=NWintFileSearchContinue(FVolume.Connection.Handle,
                                volNum,
                                dirID,
                                iter,
                                $FF,
                                StrPcopy(buf2,Items[i].text),
                                @info,
                                0);
        if (ccode<>0) then delete (i);
     end;
     for i:=1 to ItemCount do
     begin
        if Items[i].expanded=True then
        begin
           iter := $ffff;
           StrPcopy(buf,Items[i].FullPath);
           ccode:=NWintFileSearchInitialize(FVolume.Connection.Handle,
                                0,
                                @buf[0],
                                @VolNum,
                                @DirID,
                                @Iter,
                                @Acces,
                                0);
           repeat
              ccode:=NWintFileSearchContinue(FVolume.Connection.Handle,
                                volNum,
                                dirID,
                                iter,
                                $FF,
                                '*',
                                @info,
                                0);
              if (ccode=0) then
              begin
                 if find(Items[i].FullPath+'\'+StrPas(info.Dir.DirectoryName))=-1 then
                    AddChild (i,StrPas(info.Dir.DirectoryName));
              end;
              iter:=info.fich.SequenceNumber;
           until ccode <>0;
        end;
     end;
  end;
end;

{*********************************************}
{*             Class TNWFile                 *}
{*********************************************}
constructor TNWFile.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);

  FDirectory:=nil;
  Style:=lbOwnerDrawFixed;
  ListObj:=nil;
  ListObj:=TList.Create;
  LoadImage;
end;

destructor TNWFile.Destroy;
begin
  objectDestroy;
  ListObj.Free;
  inherited Destroy;
end;

procedure TNWFile.Notification(AComponent: TComponent;Operation: TOperation);
begin
  inherited Notification(AComponent, Operation);
  if (Operation = opRemove) and (AComponent = FDirectory) then
    FDirectory:=nil;
end;

procedure TNWFile.LoadImage;
begin
  if Image_FILE=nil then
  begin
     Image_FILE:=TBitmap.Create;
     Image_FILE.Handle :=LoadBitmap(HInstance, 'NW_FILE');
     Image_DIR:=TBitmap.Create;
     Image_DIR.Handle :=LoadBitmap(HInstance, 'NW_DIR');
     Image_EXEFILE:=TBitmap.Create;
     Image_EXEFILE.Handle :=LoadBitmap(HInstance, 'NW_EXEFILE');
  end;
end;

procedure TNWFile.FreeImage;
begin
  if Image_FILE<>nil then
  begin
     Image_FILE.Destroy;
     Image_DIR.Destroy;
     Image_EXEFILE.Destroy;
  end;
end;

procedure TNWFile.SetDirectory (dir: TNWdirectory);
begin
  FDirectory:=dir;
  Refresh;
end;

{Mode: FF pour les repertoires FE pour les fichiers}
procedure TNWFile.Scan (path: String;mode: byte);
var
  volNum: byte;
  dirid: word;
  iter: word;
  acces: byte;
  ccode: word;
  info: SEARCH_INFO;
  buf: array [0..255] of char;
  InfoDir: TNWInfoDirectory;
  InfoFile: TNWInfoFile;
  a: integer;
begin

  if (FDirectory.FVolume<>nil) and
     (FDirectory.FVolume.Connection<>nil) and
     (FDirectory.FVolume.Connection.Handle<>0) and
     (path<>'')  then
  begin
     StrPcopy(buf,path);
     iter := $ffff;
     ccode:=NWintFileSearchInitialize(FDirectory.FVolume.Connection.Handle,
                                0,
                                @buf[0],
                                @VolNum,
                                @DirID,
                                @Iter,
                                @Acces,
                                0);
     repeat
        ccode:=NWintFileSearchContinue(FDirectory.FVolume.Connection.Handle,
                                volNum,
                                dirID,
                                iter,
                                mode,
                                '*',
                                @info,
                                0);
        if (ccode=0) then
        begin
           if (mode= $EF) then
           begin {Fichier}
              InfoFile:=TNWInfoFile.create(path+'\'+info.Fich.Filename,info.fich,FDirectory.FVolume.Connection);
              a:=Items.AddObject(StrPas(info.Fich.Filename),InfoFile);
              ListObj.Add(Items.Objects[a]);
           end
           else
           begin {Directory}
              InfoDir:=TNWInfoDirectory.create(path+'\'+info.Dir.DirectoryName,info.dir,FDirectory.FVolume.Connection);
              a:=Items.AddObject(StrPas(info.Dir.DirectoryName),InfoDir);
              ListObj.Add(Items.Objects[a]);
           end;
        end;
        iter:=info.fich.SequenceNumber;
     until ccode <>0;
  end;
end;

procedure TNWFile.DrawItem(Index: Integer; Rect: TRect; State: TOwnerDrawState);
var
  i: integer;
  ch: array [0..255] of char;
begin
  if (Items.Objects[Index] is TNWInfoDirectory) then
     DrawList(self,index,rect,State,Image_DIR)
  else
  begin
     StrPcopy (ch,Items[Index]);
     i:=0;
     while (ch[i]<>#0) and (ch[i]<>'.') do
        i:=i+1;
     if (ch[i]='.') and (StrPas(@ch[i+1])='EXE') then
        DrawList(self,index,rect,State,Image_EXEFILE)
     else
        DrawList(self,index,rect,State,Image_FILE);
  end;
end;

procedure TNWFile.Refresh;
var
  i: longint;
begin
  i:=ItemIndex;
  ObjectDestroy;
  Items.Clear;
  if (FDirectory<>Nil) then
  begin
     Scan (Fdirectory.AllPath,$FF);  {Les Repertoires}
     Scan (Fdirectory.AllPath,$EF);  {Les Fichiers}
     if (i=-1) then i:=0;
     if (Items.count<=i) then ItemIndex:=items.count-1 else ItemIndex:=i;
  end;
end;

procedure TNWFile.BidString (toto: String);
begin
  {C'est bidon}
end;

function TNWFile.GetAllPath: String;
begin
  if (FDirectory<>Nil) and (ItemIndex<>-1) then
     result:=FDirectory.AllPath+'\'+Items[ItemIndex]
  else
     result:='';
end;

function TNWFile.GetPath :String;
begin
  if FDirectory<>nil then
     result:=FDirectory.AllPath
  else
     result:='';
end;

function TNWFile.GetFichier :String;
begin
  if ItemIndex<>-1 then
     result:=Items[ItemIndex]
  else
     result:='';
end;

procedure TNWFile.DblClick;
begin
  inherited DblClick;
  if (ItemIndex<>-1) and(Items.Objects[ItemIndex] Is TNWInfoDirectory) then
  begin
     if Fdirectory<> nil then
        FDirectory.Expand(AllPath);
  end;
end;

function TNWFile.GetFileObject: TNWInfoFile;
begin
  if (ItemIndex<>-1) and (Items.Objects[ItemIndex] Is TNWInfoFile) then
     result:=(Items.Objects[ItemIndex] As TNWInfoFile)
  else
     result:=nil;
end;

procedure TNWFile.SetFileObject(Fo: TNWInfoFile);
begin
  {Bidon}
end;

function TNWFile.GetDirObject: TNWInfoDirectory;
begin
  if (ItemIndex<>-1) and (Items.Objects[ItemIndex] Is TNWInfoDirectory) then
     result:=(Items.Objects[ItemIndex] As TNWInfoDirectory)
  else
     result:=nil;
end;

procedure TNWFile.SetDirObject(Fo: TNWInfoDirectory);
begin
  {Bidon}
end;

function TNWFile.GetType: String;
begin
   if (ItemIndex<>-1) and (Items.Objects[ItemIndex] Is TNWInfoDirectory) then
     result:='directory'
   else
     result:='file';
end;

procedure TNWFile.ObjectDestroy;
var
i: integer;
begin
  if (ListObj<>nil) then
     while ListObj.count<>0 do
        begin
           TObject(ListObj.Items[0]).Free;
           ListObj.delete(0);
        end;
end;

{*********************************************}
{*             Class TNWFileSystem           *}
{*********************************************}

constructor TNWFileSystem.Create (Aowner: Tcomponent);
begin
  inherited Create(AOwner);
end;

destructor TNWFileSystem.Destroy;
begin
  inherited Destroy;
end;

{droit:
TA_ALL     TA_READ    TA_WRITE      TA_OPEN
TA_CREATE  TA_DELETE  TA_OWNERSHIP  TA_MODIFY
result: 0 SI OK Sinon Erreur}
function TNWFileSystem.CreateDirectory (name: String): word;
var
  buf: array [0..255] of char;
begin
  name:=Uppercase(name);
  if (Fconn<>nil) and (Fconn.Handle<>0) then
     result:=NWCreatedirectory(FConn.Handle,0,StrPcopy(buf,name),$ff)
  else
     result:=$ffff;
end;

{result: 0 SI OK Sinon Erreur}
function TNWFileSystem.DeleteDirectory (name: String): word;
var
  buf: array [0..255] of char;
begin
  name:=Uppercase(name);
  if (Fconn<>nil) and (Fconn.Handle<>0) then
     result:=NWDeleteDirectory(FConn.Handle,0,StrPcopy(buf,name))
  else
     result:=$ffff;
end;

{result: 0 SI OK Sinon Erreur}
function TNWFileSystem.RenameDirectory (OldName: String;NewName: String): word;
var
  buf: array [0..255] of char;
  buf2: array [0..255] of char;
begin
  OldName:=Uppercase(OldName);
  NewName:=Uppercase(NewName);

  if (Fconn<>nil) and (Fconn.Handle<>0) then
     result:=NWRenameDirectory(FConn.Handle,0,StrPcopy(buf,OldName),StrPcopy(buf2,NewName))
  else
     result:=$ffff;
end;

{result: 0 SI OK Sinon Erreur}
function TNWFileSystem.EraseFile (name: String): word;
var
  buf: array [0..255] of char;
begin
  name:=Uppercase(name);
  if (Fconn<>nil) and (Fconn.Handle<>0) then
     result:=NWIntEraseFiles(FConn.Handle,0,StrPcopy(buf,name),$06,0)
  else
     result:=$ffff;
end;

{result: 0 SI OK Sinon Erreur}
function TNWFileSystem.RenameFile (OldName: String;NewName: String): word;
var
  buf: array [0..255] of char;
  buf2: array [0..255] of char;
begin
  OldName:=Uppercase(OldName);
  NewName:=Uppercase(NewName);
  if (Fconn<>nil) and (Fconn.Handle<>0) then
     result:=NWRenameFile(FConn.Handle,0,StrPcopy(buf,OldName),$EF,0,StrPcopy(buf2,NewName))
  else
     result:=$ffff;
end;


{*********************************************}
{*             Class TNWInfoFile             *}
{*********************************************}

{**** Ecrit les attributs avec un mask de bits ***}
  procedure TNWInfoFile.WriteAttr (mot: byte; flag: byte; val: boolean);
  var
     t: byte;
  begin
     if (val= True) then
     begin
        if (mot and flag)=0 then
           ModifyAttribute (FAllPath,mot or flag);
     end
     else
     begin
        if (mot and flag)<>0 then
           ModifyAttribute (FAllPath,mot and (not flag));
     end;
  end;

function TNWInfoFile.ModifyAttribute(Name: String;attr: byte): word;
var
  buf: array [0..255] of char;
  search: byte;
begin
  if (Fconn<>nil) and (Fconn.Handle<>0) then
  begin
     name:=Uppercase(name);
     search:=$EF;
     result:=NWSetFileAttributes(FConn.Handle,0,StrPcopy(buf,Name),search,attr);
     if result=0 then
        FileAttributes:=attr;
  end
  else
     result:=$ffff;
end;

  function  TNWInfoFile.GetFAReadOnly       :boolean;
  begin
     result:=Decode(FileAttributes,FA_READ_ONLY);
  end;

  procedure TNWInfoFile.SetFAReadOnly       (val: boolean);
  begin
     WriteAttr(FileAttributes,FA_READ_ONLY,val);
  end;

  function  TNWInfoFile.GetFAHidden         :boolean;
  begin
     result:=Decode(FileAttributes,FA_HIDDEN);
  end;

  procedure TNWInfoFile.SetFAHidden         (val: boolean);
  begin
     WriteAttr(FileAttributes,FA_HIDDEN,val);
  end;

  function  TNWInfoFile.GetFASystem         :boolean;
  begin
     result:=Decode(FileAttributes,FA_SYSTEM);
  end;

  procedure TNWInfoFile.SetFASystem         (val: boolean);
  begin
     WriteAttr(FileAttributes,FA_SYSTEM,val);
  end;

  function  TNWInfoFile.GetFAExecuteOnly    :boolean;
  begin
     result:=Decode(FileAttributes,FA_EXECUTE_ONLY);
  end;

  procedure TNWInfoFile.SetFAExecuteOnly    (val: boolean);
  begin
     WriteAttr(FileAttributes,FA_EXECUTE_ONLY,val);
  end;

  function  TNWInfoFile.GetFAShareable      :boolean;
  begin
     result:=Decode(FileAttributes,FA_SHAREABLE);
  end;

  procedure TNWInfoFile.SetFAShareable      (val: boolean);
  begin
     WriteAttr(FileAttributes,FA_SHAREABLE,val);
  end;

  function  TNWInfoFile.GetFMOpenForRead          :boolean;
  begin
     result:=Decode(FileMode,$01);
  end;

  function  TNWInfoFile.GetFMOpenForWrite          :boolean;
  begin
     result:=Decode(FileMode,$02);
  end;

  function  TNWInfoFile.GetFMDenyReadFromOthers   :boolean;
  begin
     result:=Decode(FileMode,$04);
  end;
  function  TNWInfoFile.GetFMDenyWriteFromOthers  :boolean;
  begin
     result:=Decode(FileMode,$08);
  end;

  function  TNWInfoFile.GetFMFileDetach           :boolean;
  begin
     result:=Decode(FileMode,$10);
  end;

  function  TNWInfoFile.GetFMTTSHoldingDetach     :boolean;
  begin
     result:=Decode(FileMode,$20);
  end;

  function  TNWInfoFile.GetFMTTSHoldingOpen       :boolean;
  begin
     result:=Decode(FileMode,$40);
  end;

  function  TNWInfoFile.GetJour    :word;
  begin
     result:=(UpdateDate and $001F);
  end;

  function  TNWInfoFile.GetMois    :word;
  begin
     result:=(UpdateDate and $01E0) shr 5;
  end;

  function  TNWInfoFile.GetAnnee   :word;
  begin
     result:=(UpdateDate and $FE00) shr 9+1980;
  end;

  function  TNWInfoFile.GetHeure   :word;
  begin
     result:=(UpdateTime and $F800) shr 11;
  end;

  function  TNWInfoFile.GetMinute  :word;
  begin
     result:=(UpdateTime and $07E0) shr 5;
  end;

  function  TNWInfoFile.GetSeconde :word;
  begin
     result:=(UpdateTime and $001f)*2;
  end;


{*********************************************}
{*             Class TNWDirectory            *}
{*********************************************}

{**** Ecrit les attributs avec un mask de bits ***}
  procedure TNWInfoDirectory.WriteAttr (mot: byte; flag: byte; val: boolean);
  var
     t: byte;
  begin
     if (val= True) then
        ModifyAttribute (FAllPath,mot or flag)
     else
        ModifyAttribute (FAllPath,mot and (not flag));
  end;

function TNWInfoDirectory.ModifyAttribute(Name: String;attr: byte): word;
var
  buf: array [0..255] of char;
  search: byte;
begin
  if (Fconn<>nil) and (Fconn.Handle<>0) then
  begin
     name:=Uppercase(name);
     search:=$FF;
     result:=NWSetFileAttributes(FConn.Handle,0,StrPcopy(buf,Name),search,attr);
     if result=0 then
        DirectoryAttributes:=attr;
  end
  else
     result:=$ffff;
end;

function TNWInfoDirectory.ModifyDirectory (name: String;date: word; time: word;owner: longint;right :byte): word;
var
  buf: array [0..255] of char;
  DateTime: longint;
begin
  name:=Uppercase(name);
  if (Fconn<>nil) and (Fconn.Handle<>0) then
  begin
     DateTime:=longint(date) shl 16;
     DateTime:=DateTime+longint(time);
     result:=NWSetDirectoryInformation(Fconn.Handle,0,StrPcopy(buf,name),DateTime,owner,right);
     if result=0 then
        DirectoryAccessRights:=right;
  end
  else
     result:=$ffff;
end;

  {**** Ecrit les droits d'un directory avec un mask de bits ***}
  procedure TNWInfoDirectory.WriteRight (mot: byte; flag: byte; val: boolean);
  var
     t: byte;
  begin
     if (val= True) then
     begin
        if (mot and flag)=0 then
           ModifyDirectory (FAllPath,CreateDate,CreateTime,nwlongswap(OwningObjectId),mot or flag);
     end
     else
     begin
        if (mot and flag)<>0 then
           ModifyDirectory (FAllPath,CreateDate,CreateTime,OwningObjectId,mot and (not flag));
     end;
  end;


function  TNWInfoDirectory.GetDAHidden      :boolean;
begin
     result:=Decode(DirectoryAttributes,FA_HIDDEN);
end;

procedure TNWInfoDirectory.SetDAHidden      (val: boolean);
begin
     WriteAttr(DirectoryAttributes,FA_HIDDEN,val);
end;

function  TNWInfoDirectory.GetDASystem      :boolean;
begin
     result:=Decode(DirectoryAttributes,FA_SYSTEM);
end;

procedure TNWInfoDirectory.SetDASystem      (val: boolean);
begin
     WriteAttr(DirectoryAttributes,FA_SYSTEM,val);
end;

function  TNWInfoDirectory.GetDRRead        :boolean;
begin
     result:=Decode(DirectoryAccessRights,$01);
end;

procedure TNWInfoDirectory.SetDRRead        (val: boolean);
begin
     WriteRight(DirectoryAccessRights,$01,val);
end;

function  TNWInfoDirectory.GetDRWrite       :boolean;
begin
     result:=Decode(DirectoryAccessRights,$02);
end;

procedure TNWInfoDirectory.SetDRWrite       (val: boolean);
begin
     WriteRight(DirectoryAccessRights,$02,val);
end;

function  TNWInfoDirectory.GetDROpen        :boolean;
begin
     result:=Decode(DirectoryAccessRights,$04);
end;

procedure TNWInfoDirectory.SetDROpen        (val: boolean);
begin
     WriteRight(DirectoryAccessRights,$04,val);
end;

function  TNWInfoDirectory.GetDRCreate      :boolean;
begin
     result:=Decode(DirectoryAccessRights,$08);
end;

procedure TNWInfoDirectory.SetDRCreate      (val: boolean);
begin
     WriteRight(DirectoryAccessRights,$08,val);
end;

function  TNWInfoDirectory.GetDRDelete      :boolean;
begin
     result:=Decode(DirectoryAccessRights,$10);
end;

procedure TNWInfoDirectory.SetDRDelete      (val: boolean);
begin
     WriteRight(DirectoryAccessRights,$10,val);
end;

function  TNWInfoDirectory.GetDROwnership   :boolean;
begin
     result:=Decode(DirectoryAccessRights,$20);
end;

procedure TNWInfoDirectory.SetDROwnership   (val: boolean);
begin
     WriteRight(DirectoryAccessRights,$20,val);
end;

function  TNWInfoDirectory.GetDRSearch      :boolean;
begin
     result:=Decode(DirectoryAccessRights,$40);
end;

procedure TNWInfoDirectory.SetDRSearch      (val: boolean);
begin
     WriteRight(DirectoryAccessRights,$40,val);
end;

function  TNWInfoDirectory.GetDRModify      :boolean;
begin
     result:=Decode(DirectoryAccessRights,$80);
end;

procedure TNWInfoDirectory.SetDRModify      (val: boolean);
begin
     WriteRight(DirectoryAccessRights,$80,val);
end;

function  TNWInfoDirectory.GetJour    :word;
begin
     result:=(CreateDate and $001F);
end;

function  TNWInfoDirectory.GetMois    :word;
begin
     result:=(CreateDate and $01E0) shr 5;
end;

function  TNWInfoDirectory.GetAnnee   :word;
begin
     result:=(CreateDate and $FE00) shr 9 +1980;
end;

function  TNWInfoDirectory.GetHeure   :word;
begin
     result:=(CreateTime and $F800) shr 11;
end;

function  TNWInfoDirectory.GetMinute  :word;
begin
     result:=(CreateTime and $07E0) shr 5;
end;

function  TNWInfoDirectory.GetSeconde :word;
begin
     result:=(CreateTime and $001f)*2;
end;

procedure TNWInfoDirectory.SetProprietaire (nom: String);
var
  buf: array [0..255] of char;
  buf2: array [0..255] of char;
  datetime: longint;
  nomId: longint;
  ccode: word;
begin
     DateTime:=longint(Createdate) shl 16;
     DateTime:=DateTime+longint(Createtime);
     if (FConn<>nil) and (Fconn.Handle<>0) then
     begin
        ccode:=NWGetObjectID(Fconn.Handle,StrPcopy(buf,nom),OT_USER,@NomID);
        ccode:=NWSetDirectoryInformation
           (Fconn.Handle,0,StrPcopy(buf,FAllPath),datetime,NomID,DirectoryAccessRights);
        if ccode = 0 then
           owningObjectID:=nwlongswap(NomID);
     end;
end;

function  TNWInfoDirectory.GetProprietaire :String;
var
  buf: array [0..255] of char;
  ccode: word;
begin
  if (FConn<>nil) and (Fconn.Handle<>0) then
  begin
     ccode:=NWGetObjectName (Fconn.Handle,nwlongswap(owningObjectId),buf,nil);
     if (ccode =0) then
        result:=StrPas(buf)
     else
        result:='';
  end;

end;

end.
