
{*******************************************************}
{                                                       }
{   (195) Fonctions                                     }
{   du Novell 4.0 Pour Borland DELPHI                   }
{                                                       }
{   Convertion du C au PASCAL                           }
{   par Couery Tanguy le 26/11/95                       }
{                                                       }
{   Pour le projet Novell Netware de 3me anne         }
{   (BRETIN David,COUERY Tanguy,GUILHEM Eric)           }
{                                                       }
{                                                       }
{*******************************************************}

unit NwNet;

interface

uses TNet;

function NWInitUnicodeTables (
	countryCode: integer;
	codePage: integer): integer;

function NWFreeUnicodeTables: integer;

function NWLoadRuleTable (
	ruleTableName: Pchar;
	ruleHandle: Ppointer): integer;

function NWUnloadRuleTable (
	ruleHandle: pointer): integer;

function NWLocalToUnicode (
	ruleHandle: pointer;
	dest: Punicode;
	maxLen: size_t;
	src: Pbyte;
	noMap: unicode;
	len: Psize_t): integer;

function NWUnicodeToLocal (
	ruleHandle: pointer;
	dest: Pbyte;
	maxLen: size_t;
	src: Punicode;
	noMap: char;
	len: Psize_t): integer;

function NWUnicodeToCollation (
	ruleHandle: pointer;
	dest: Punicode;
	maxLen: size_t;
	src: Punicode;
	noMap: unicode;
	len: Psize_t): integer;

function NWUnicodeCompare (
	ruleHandle: pointer;
	chr1: unicode;
	chr2: unicode): integer;

function NWUnicodeToMonocase (
	ruleHandle: pointer;
	dest: Punicode;
	maxLen: size_t;
	src: Punicode;
	len: Psize_t): integer;

function NWGetUnicodeToLocalHandle (
	pointerhandle: Ppointer): integer;

function NWGetLocalToUnicodeHandle (
	pointerhandle: Ppointer): integer;

function NWGetMonocaseHandle (
	pointerhandle: Ppointer): integer;

function NWGetCollationHandle (
	pointerhandle: Ppointer): integer;

function unicat (
	s1: Punicode;
	s2: Punicode): Punicode;

function unichr (
	s: Punicode;
	c: integer): Punicode;
	
function unicpy (
	s1: Punicode;
	s2: Punicode): Punicode;
	
function unicspn (
	s1: Punicode;
	s2: Punicode): size_t;
	
function unilen (
	s: Punicode): size_t;
	
function unincat (
	s1: Punicode;
	s2: Punicode;
	n: size_t): Punicode;
	
function unincpy (
	s1: Punicode;
	s2: Punicode;
	n: size_t): Punicode;
	
function uninset (
	s: Punicode;
	c: integer;
	n: size_t): Punicode;

function unipbrk (
	s1: Punicode;
	s2: Punicode): Punicode;
	
function unipcpy (
	s1: Punicode;
	s2: Punicode): Punicode;
	
function unirchr (
	s: Punicode;
	c: integer): Punicode;
	
function unirev (
	s: Punicode): Punicode;

function uniset (
	s: Punicode;
	c: integer): Punicode;
	
function unispn (
	s1: Punicode;
	s2: Punicode): size_t;

function unistr (
	s1: Punicode;
	s2: Punicode): Punicode;
	
function unitok (
	s1: Punicode;
	s2: Punicode): Punicode;
	
function uniicmp (
	s1: Punicode;
	s2: Punicode): integer;
	
function uninicmp (
	s1: Punicode;
	s2: Punicode;
	n: size_t): integer;
	
function unisize (
	s: Punicode): size_t;

function NWDSCreateContext: NWDSContextHandle;

function NWDSDuplicateContext (
	oldContext: NWDSContextHandle): NWDSContextHandle;

function NWDSFreeContext (
	context: NWDSContextHandle): integer;
	
function NWDSGetContext (
	context: NWDSContextHandle;
	key: integer;
	value: pointer): integer;
	
function NWDSSetContext (
	context: NWDSContextHandle;
	key: integer;
	value: pointer): integer;
	
function NWDSAbbreviateName (
	context: NWDSContextHandle;
	inName: Pchar;
	abbreviatedName: Pchar): integer;
	
function NWDSCanonicalizeName (
	context: NWDSContextHandle;
	objectName: Pchar;
	canonName: Pchar): integer;
	
function NWDSRemoveAllTypes (
	context: NWDSContextHandle;
	name: Pchar;
	typelessName: Pchar): integer;
	
function NWDSResolveName (
	context: NWDSContextHandle;
	objectName: Pchar;
	conn: Pword;
	objectID: Plongint): integer;
	
function NWDSCIStringsMatch (
	context: NWDSContextHandle;
	string1: Pchar;
	string2: Pchar;
	matches: Pinteger): integer;
	
function NWDSAllocBuf (
	size: size_t;
	PBuf_Tbuf: Ppointer): integer;

function NWDSComputeAttrValSize (
	context: NWDSContextHandle;
	buf: PBuf_T;
	syntaxID: longint;
	attrValSize: Plongint): integer;
	
function NWDSFreeBuf (
	buf: PBuf_T): integer;

function NWDSGetAttrCount (
	context: NWDSContextHandle;
	buf: PBuf_T;
	attrCount: Plongint): integer;
	
function NWDSGetAttrDef (
	context: NWDSContextHandle;
	buf: PBuf_T;
	attrName: Pchar;
	attrInfo: PAttr_Info_T): integer;
	
function NWDSGetAttrName (
	context: NWDSContextHandle;
	buf: PBuf_T;
	attrName: Pchar;
	attrValCount: Plongint;
	syntaxID: Plongint): integer;
	
function NWDSGetAttrVal (
	context: NWDSContextHandle;
	buf: PBuf_T;
	syntaxID: longint;
	attrVal: pointer): integer;
	
function NWDSGetClassDef (
	context: NWDSContextHandle;
	buf: PBuf_T;
	className: Pchar;
	classInfo: PClass_Info_T): integer;
	
function NWDSGetClassDefCount (
	context: NWDSContextHandle;
	buf: PBuf_T;
	classDefCount: Plongint): integer;
	
function NWDSGetClassItem (
	context: NWDSContextHandle;
	buf: PBuf_T;
	itemName: Pchar): integer;

function NWDSGetClassItemCount (
	context: NWDSContextHandle;
	buf: PBuf_T;
	itemCount: Plongint): integer;
	
function NWDSGetObjectCount (
	context: NWDSContextHandle;
	buf: PBuf_T;
	objectCount: Plongint): integer;
	
function NWDSGetObjectName (
	context: NWDSContextHandle;
	buf: PBuf_T;
	objectName: Pchar;
	attrCount: Plongint;
	objectInfo: PObject_Info_T): integer;
	
function NWDSGetPartitionInfo (
	context: NWDSContextHandle;
	buf: PBuf_T;
	partitionName: Pchar;
	replicaType: Plongint): integer;

function NWDSGetServerName (
	context: NWDSContextHandle;
	buf: PBuf_T;
	serverName: Pchar;
	partitionCount: Plongint): integer;
	
function NWDSGetSyntaxCount (
	context: NWDSContextHandle;
	buf: PBuf_T;
	syntaxCount: Plongint): integer;
	
function NWDSGetSyntaxDef (
	context: NWDSContextHandle;
	buf: PBuf_T;
	syntaxName: Pchar;
	syntaxDef: PSyntax_Info_T): integer;
	
function NWDSInitBuf (
	context: NWDSContextHandle;
	operation: longint;
	buf: PBuf_T): integer;
	
function NWDSPutAttrName (
	context: NWDSContextHandle;
	buf: PBuf_T;
	attrName: Pchar): integer;
	
function NWDSPutAttrVal (
	context: NWDSContextHandle;
	buf: PBuf_T;
	syntaxID: longint;
	attrVal: pointer): integer;
	
function NWDSPutChange (
	context: NWDSContextHandle;
	buf: PBuf_T;
	changeType: longint;
	attrName: Pchar): integer;
	
function NWDSPutClassItem (
	context: NWDSContextHandle;
	buf: PBuf_T;
	itemName: Pchar): integer;

function NWDSBeginClassItem (
	context: NWDSContextHandle;
	buf: PBuf_T): integer;

function NWDSAddFilterToken (
	cur: PFilter_Cursor_T;
	tok: word;
	val: pointer;
	syntax: longint): integer;

function NWDSAllocFilter (
	PFilter_Cursor_Tcur: Ppointer): integer;

function NWDSCloseIteration (
	context: NWDSContextHandle;
	iterationHandle: longint;
	operation: longint): integer;

function NWDSGetSyntaxID (
	context: NWDSContextHandle;
	attrName: Pchar;
	syntaxID: Plongint): integer;

function NWDSReadSyntaxes (
	context: NWDSContextHandle;
	infoType: longint;
	allSyntaxes: byte;
	syntaxNames: PBuf_T;
	iterationHandle: Plongint;
	syntaxDefs: PBuf_T): integer;
	
function NWDSReadSyntaxDef (
	context: NWDSContextHandle;
	syntaxID: longint;
	syntaxDef: PSyntax_Info_T): integer;
	
function NWDSReplaceAttrNameAbbrev (
	context: NWDSContextHandle;
	inStr: Pchar;
	outStr: Pchar): integer;
	
function NWDSGetObjectHostServerAddress (
	context: NWDSContextHandle;
	objectName: Pchar;
	serverName: Pchar;
	netAddresses: PBuf_T): integer;
	
procedure NWGetNWNetVersion (
	majorVersion: Pbyte;
	minorVersion: Pbyte;
	revisionLevel: Pbyte;
	betaReleaseLevel: Pbyte);
	
function NWIsDSServer (
	conn: word;
	treeName: Pchar): integer;
	
function NWDSGetBinderyContext (
	context: NWDSContextHandle;
	conn: word;
	BinderyEmulationContext: Pbyte): integer;
	
function NWDSRepairTimeStamps (
	context: NWDSContextHandle;
	partitionRoot: Pchar): integer;
	
function NWGetFileServerUTCTime (
	conn: word;
	time: Plongint): integer;
	
function NWDSGetEffectiveRights (
	context: NWDSContextHandle;
	subjectName: Pchar;
	objectName: Pchar;
	attrName: Pchar;
	privileges: Plongint): integer;
	
function NWDSListAttrsEffectiveRights (
	context: NWDSContextHandle;
	objectName: Pchar;
	subjectName: Pchar;
	allAttrs: byte;
	attrNames: PBuf_T;
	iterationHandle: Plongint;
	privilegeInfo: PBuf_T): integer;
	
function NWDSAuditGetObjectID (
	context: NWDSContextHandle;
	objectName: Pchar;
	conn: Pword;
	objectID: Plongint): integer;
	
function NWDSAddObject (
	context: NWDSContextHandle;
	objectName: Pchar;
	iterationHandle: Plongint;
	more: byte;
	objectInfo: PBuf_T): integer;
	
function NWDSBackupObject (
	context: NWDSContextHandle;
	objectName: Pchar;
	iterationHandle: Plongint;
	objectInfo: PBuf_T): integer;
	
function NWDSCompare (
	context: NWDSContextHandle;
	_object: Pchar;
	buf: PBuf_T;
	matched: Pbyte): integer;
	
function NWDSGetPartitionRoot (
	context: NWDSContextHandle;
	objectName: Pchar;
	partitionRoot: Pchar): integer;
	
function NWDSList (
	context: NWDSContextHandle;
	_object: Pchar;
	iterationHandle: Plongint;
	subordinates: PBuf_T): integer;
	
function NWDSListContainers (
	context: NWDSContextHandle;
	_object: Pchar;
	iterationHandle: Plongint;
	subordinates: PBuf_T): integer;

function NWDSListByClassAndName (
	context: NWDSContextHandle;
	objectName: Pchar;
	className: Pchar;
	subordinateName: Pchar;
	iterationHandle: Plongint;
	subordinates: PBuf_T): integer;
	
function NWDSGetCountByClassAndName (
	context: NWDSContextHandle;
	objectName: Pchar;
	className: Pchar;
	subordinateName: Pchar;
	count: Plongint): integer;
	
function NWDSMapIDToName (
	context: NWDSContextHandle;
	conn: word;
	objectID: longint;
	_object: Pchar): integer;
	
function NWDSMapNameToID (
	context: NWDSContextHandle;
	conn: word;
	_object: Pchar;
	objectID: Plongint): integer;
	
function NWDSModifyObject (
	context: NWDSContextHandle;
	objectName: Pchar;
	iterationHandle: Plongint;
	more: byte;
	changes: PBuf_T): integer;
	
function NWDSModifyDN (
	context: NWDSContextHandle;
	objectName: Pchar;
	newDN: Pchar;
	deleteOldRDN: byte): integer;
	
function NWDSModifyRDN (
	context: NWDSContextHandle;
	objectName: Pchar;
	newDN: Pchar;
	deleteOldRDN: byte): integer;
	
function NWDSMoveObject (
	context: NWDSContextHandle;
	objectName: Pchar;
	destParentDN: Pchar;
	destRDN: Pchar): integer;

function NWDSRead (
	context: NWDSContextHandle;
	_object: Pchar;
	infoType: longint;
	allAttrs: byte;
	attrNames: PBuf_T;
	iterationHandle: Plongint;
	objectInfo: PBuf_T): integer;
	
function NWDSReadObjectInfo (
	context: NWDSContextHandle;
	_object: Pchar;
	distinguishedName: Pchar;
	objectInfo: PObject_Info_T): integer;
	
function NWDSRemoveObject (
	context: NWDSContextHandle;
	_object: Pchar): integer;
	
function NWDSRestoreObject (
	context: NWDSContextHandle;
	objectName: Pchar;
	iterationHandle: Plongint;
	more: byte;
	size: longint;
	objectInfo: Pbyte): integer;

function NWDSSearch (
	context: NWDSContextHandle;
	baseObjectName: Pchar;
	scope: integer;
	searchAliases: byte;
	filter: PBuf_T;
	infoType: longint;
	allAttrs: byte;
	attrNames: PBuf_T;
	iterationHandle: Plongint;
	countObjectsToSearch: longint;
	countObjectsSearched: Plongint;
	objectInfo: PBuf_T): integer;

function NWDSOpenStream (
	context: NWDSContextHandle;
	objectName: Pchar;
	attrName: Pchar;
	flags: longint;
	fileHandle: Pinteger): integer;
	
function NWDSWhoAmI (
	context: NWDSContextHandle;
	objectName: Pchar): integer;

function NWDSGetServerDN (
	context: NWDSContextHandle;
	conn: word;
	serverDN: Pchar): integer;
	
function NWDSGetServerAddresses (
	context: NWDSContextHandle;
	conn: word;
	countNetAddress: Plongint;
	netAddresses: PBuf_T): integer;
	
function NWDSInspectEntry (
	context: NWDSContextHandle;
	serverName: Pchar;
	objectName: Pchar;
	errBuffer: PBuf_T): integer;
	
function NWDSReadReferences (
	context: NWDSContextHandle;
	serverName: Pchar;
	objectName: Pchar;
	infoType: longint;
	allAttrs: byte;
	attrNames: PBuf_T;
	timeFilter: longint;
	iterationHandle: Plongint;
	objectInfo: PBuf_T): integer;

function NWDSExtSyncList (
	context: NWDSContextHandle;
	objectName: Pchar;
	className: Pchar;
	subordinateName: Pchar;
	iterationHandle: Plongint;
	timeStamp: PTimeStamp_T;
	onlyContainers: integer;
	subordinates: PBuf_T): integer;
	
function NWDSExtSyncRead (
	context: NWDSContextHandle;
	objectName: Pchar;
	infoType: longint;
	allAttrs: byte;
	attrNames: PBuf_T;
	iterationHandle: Plongint;
	timeStamp: PTimeStamp_T;
	objectInfo: PBuf_T): integer;
	
function NWDSExtSyncSearch (
	context: NWDSContextHandle;
	baseObjectName: Pchar;
	scope: integer;
	searchAliases: byte;
	filter: PBuf_T;
	timeStamp: PTimeStamp_T;
	infoType: longint;
	allAttrs: byte;
	attrNames: PBuf_T;
	iterationHandle: Plongint;
	countObjectsToSearch: longint;
	countObjectsSearched: Plongint;
	objectInfo: PBuf_T): integer;
	
function NWDSRemSecurityEquiv (
	context: NWDSContextHandle;
	equalFrom: Pchar;
	equalTo: Pchar): integer;
	
function NWDSAddSecurityEquiv (
	context: NWDSContextHandle;
	equalFrom: Pchar;
	equalTo: Pchar): integer;

function NWDSDefineAttr (
	context: NWDSContextHandle;
	attrName: Pchar;
	attrDef: PAttr_Info_T): integer;

function NWDSDefineClass (
	context: NWDSContextHandle;
	className: Pchar;
	classInfo: PClass_Info_T;
	classItems: PBuf_T): integer;
	
function NWDSListContainableClasses (
	context: NWDSContextHandle;
	parentObject: Pchar;
	iterationHandle: Plongint;
	containableClasses: PBuf_T): integer;
	
function NWDSModifyClassDef (
	context: NWDSContextHandle;
	className: Pchar;
	optionalAttrs: PBuf_T): integer;
	
function NWDSReadAttrDef (
	context: NWDSContextHandle;
	infoType: longint;
	allAttrs: byte;
	attrNames: PBuf_T;
	iterationHandle: Plongint;
	attrDefs: PBuf_T): integer;
	
function NWDSReadClassDef (
	context: NWDSContextHandle;
	infoType: longint;
	allClasses: byte;
	classNames: PBuf_T;
	iterationHandle: Plongint;
	classDefs: PBuf_T): integer;
	
function NWDSRemoveAttrDef (
	context: NWDSContextHandle;
	attrName: Pchar): integer;

function NWDSRemoveClassDef (
	context: NWDSContextHandle;
	className: Pchar): integer;

function NWDSAuthenticate (
	conn: word;
	optionsFlag: longint;
	sessionKey: PNWDS_Session_Key_T): integer;
	
function NWDSChangeObjectPassword (
	context: NWDSContextHandle;
	optionsFlag: longint;
	objectName: Pchar;
	oldPassword: Pchar;
	newPassword: Pchar): integer;
	
function NWDSGenerateObjectKeyPair (
	contextHandle: NWDSContextHandle;
	objectName: Pchar;
	objectPassword: Pchar;
	optionsFlag: longint): integer;
	
function NWDSLogin (
	context: NWDSContextHandle;
	optionsFlag: longint;
	objectName: Pchar;
	password: Pchar;
	validityPeriod: longint): integer;
	
function NWDSLogout (
	context: NWDSContextHandle): integer;
	
function NWDSVerifyObjectPassword (
	context: NWDSContextHandle;
	optionsFlag: longint;
	objectName: Pchar;
	password: Pchar): integer;
	
function NWDSAddPartition (
	context: NWDSContextHandle;
	server: Pchar;
	partitionRoot: Pchar;
	iterationHandle: Plongint;
	more: byte;
	objectInfo: PBuf_T): integer;

function NWDSAddReplica (
	context: NWDSContextHandle;
	server: Pchar;
	partitionRoot: Pchar;
	replicaType: longint): integer;
	
function NWDSChangeReplicaType (
	context: NWDSContextHandle;
	replicaName: Pchar;
	server: Pchar;
	newReplicaType: longint): integer;

function NWDSJoinPartitions (
	context: NWDSContextHandle;
	subordinatePartition: Pchar;
	flags: longint): integer;
	
function NWDSListPartitions (
	context: NWDSContextHandle;
	iterationHandle: Plongint;
	server: Pchar;
	partitions: PBuf_T): integer;

function NWDSRemovePartition (
	context: NWDSContextHandle;
	partitionRoot: Pchar): integer;

function NWDSRemoveReplica (
	context: NWDSContextHandle;
	server: Pchar;
	partitionRoot: Pchar): integer;
	
function NWDSSplitPartition (
	context: NWDSContextHandle;
	subordinatePartition: Pchar;
	flags: longint): integer;
	
function NWDSPartitionReceiveAllUpdates (
	context: NWDSContextHandle;
	partitionRoot: Pchar;
	serverName: Pchar): integer;
	
function NWDSPartitionSendAllUpdates (
	context: NWDSContextHandle;
	partitionRoot: Pchar;
	serverName: Pchar): integer;

function NWDSSyncPartition (
	context: NWDSContextHandle;
	server: Pchar;
	partition: Pchar;
	seconds: longint): integer;
	
function NWDSAbortPartitionOperation (
	context: NWDSContextHandle;
	partitionRoot: Pchar): integer;
	
function NWGetVolumeAuditStats (
	conn: word;
	volumeNumber: longint;
	auditStatus: PNWVolumeAuditStatus;
	auditStatusSize: word): word;
	
function NWAddAuditProperty (
	conn: word;
	volumeNumber: longint;
	auditKey: Pbyte;
	userID: longint): word;

function NWLoginAsVolumeAuditor (
	conn: word;
	volumeNumber: longint;
	auditKey: Pbyte;
	password: Pbyte): word;

function NWInitAuditLevelTwoPassword (
	auditKey: Pbyte;
	password: Pbyte): word;
	
function NWChangeAuditorPassword (
	conn: word;
	volumeNumber: longint;
	auditKey: Pbyte;
	newPassword: Pbyte;
	level: byte): word;

function NWCheckAuditAccess (
	conn: word;
	volumeNumber: longint): word;
	
function NWCheckAuditLevelTwoAccess (
	conn: word;
	volumeNumber: longint;
	auditKey: Pbyte): word;
	
function NWGetAuditingFlags (
	conn: word;
	volumeNumber: longint;
	auditKey: Pbyte;
	flags: Pbyte): word;
	
function NWRemoveAuditProperty (
	conn: word;
	volumeNumber: longint;
	auditKey: Pbyte;
	userID: longint): word;
	
function NWDisableAuditingOnVolume (
	conn: word;
	volumeNumber: longint;
	auditKey: Pbyte): word;

function NWEnableAuditingOnVolume (
	conn: word;
	volumeNumber: longint;
	auditKey: Pbyte): word;
	
function NWIsUserBeingAudited (
	conn: word;
	volumeNumber: longint;
	auditKey: Pbyte;
	userID: longint): word;
	
function NWReadAuditingBitMap (
	conn: word;
	volumeNumber: longint;
	auditKey: Pbyte;
	buffer: PNWEventBitMap;
	bufferSize: word): word;
	
function NWReadAuditConfigHeader (
	conn: word;
	volumeNumber: longint;
	auditKey: Pbyte;
	buffer: PNWConfigHeader;
	bufferSize: word): word;
	
function NWReadAuditingFileRecord (
	volumeContainerID: longint;
	fileCode: shortint;
	buffer: pointer;
	bufferSize: Pword;
	maxSize: word;
	eofFlag: Pbyte): word;
	
function NWInitAuditFileRead (
	conn: word;
	volumeContainerID: longint;
	fileCode: shortint;
	DSFlag: shortint): word;

function NWLogoutAsVolumeAuditor (
	conn: word;
	volumeNumber: longint;
	auditKey: Pbyte): word;

function NWResetAuditHistoryFile (
	conn: word;
	volumeNumber: longint;
	auditKey: Pbyte): word;

function NWResetAuditingFile (
	conn: word;
	volumeNumber: longint;
	auditKey: Pbyte): word;
	
function NWWriteAuditingBitMap (
	conn: word;
	volumeNumber: longint;
	auditKey: Pbyte;
	buffer: PNWEventBitMap): word;
	
function NWWriteAuditConfigHeader (
	conn: word;
	volumeNumber: longint;
	auditKey: Pbyte;
	buffer: PNWConfigHeader): word;
	
function NWCloseOldAuditingFile (
	conn: word;
	volumeNumber: longint;
	auditKey: Pbyte): word;

function NWDeleteOldAuditingFile (
	conn: word;
	volumeNumber: longint;
	auditKey: Pbyte): word;

function NWDSChangeAuditorPassword (
	conn: word;
	containerID: longint;
	key: Pbyte;
	password: Pbyte;
	level: byte): word;
	
function NWDSCheckAuditAccess (
	conn: word;
	containerID: longint): word;
	
function NWDSCheckAuditLevelTwoAccess (
	conn: word;
	containerID: longint;
	key: Pbyte): word;

function NWDSCloseOldAuditingFile (
	conn: word;
	containerID: longint;
	key: Pbyte): word;
	
function NWDSDeleteOldAuditingFile (
	conn: word;
	containerID: longint;
	key: Pbyte): word;
	
function NWDSDisableAuditingOnContainer (
	conn: word;
	containerID: longint;
	key: Pbyte): word;

function NWDSEnableAuditingOnContainer (
	conn: word;
	containerID: longint;
	key: Pbyte): word;
	
function NWDSGetAuditingFlags (
	conn: word;
	containerID: longint;
	key: Pbyte;
	flags: Pbyte): word;

function NWDSGetContainerAuditStats (
	conn: word;
	containerID: longint;
	buffer: PNWContainerAuditStatus;
	auditStatusSize: word): word;
	
function NWDSLoginAsContainerAuditor (
	conn: word;
	containerID: longint;
	key: Pbyte;
	password: Pbyte): word;

function NWDSLogoutAsContainerAuditor (
	conn: word;
	containerID: longint;
	key: Pbyte): word;
	
function NWDSReadAuditConfigHeader (
	conn: word;
	containerID: longint;
	key: Pbyte;
	buffer: PNWDSContainerConfigHdr;
	bufferSize: word): word;
	
function NWDSResetAuditingFile (
	conn: word;
	containerID: longint;
	key: Pbyte): word;
	
function NWDSWriteAuditConfigHeader (
	conn: word;
	containerID: longint;
	key: Pbyte;
	buffer: PNWDSContainerConfigHdr): word;

function NWDSResetAuditHistoryFile (
	conn: word;
	containerID: longint;
	key: Pbyte): word;
	
function NWDSIsObjectBeingAudited (
	conn: word;
	containerID: longint;
	key: Pbyte;
	objectID: longint): word;

function NWDSChangeObjectAuditProperty (
	conn: word;
	containerID: longint;
	key: Pbyte;
	objectID: longint;
	auditFlag: byte): word;
	
function NWGetNearestDirectoryService (
	connID: Pword): word;
	
function NWSetDefaultNameContext (
	contextLength: word;
	context: Pbyte): word;
	
function NWGetDefaultNameContext (
	bufferSize: word;
	context: Pbyte): word;

function NWGetConnectionIDFromAddress (
	transType: byte;
	transLen: longint;
	transBuf: Pbyte;
	connID: Pword): word;
	
function NWDSGetConnectionInfo (
	connID: word;
	connStatus: Pbyte;
	connType: Pbyte;
	serverFlags: Pbyte;
	serverName: Pbyte;
	transType: Pbyte;
	transLen: Plongint;
	transBuf: Pbyte;
	distance: Pword;
	maxPacketSize: Pword): word;
	
function NWDSGetConnectionSlot (
	connType: byte;
	transType: byte;
	transLen: longint;
	transBuf: Pbyte;
	connID: Pword): word;

function NWGetPreferredDSServer (
	connID: Pword): word;

function NWSetPreferredDSTree (
	length: word;
	treeName: Pbyte): word;

function NWGetNumConnections (
	numConnections: Pword): word;
	
function NWDSGetMonitoredConnection (
	connID: Pword): word;
	
function NWDSSetMonitoredConnection (
	connID: word): word;
	
function NWGetConnectionIDFromName (
	nameLen: longint;
	name: Pbyte;
	connID: Pword): word;
	
function NWIsDSAuthenticated: word;

function NWDSLockConnection (
	connID: word): word;

function NWDSUnlockConnection (
	connID: word): word;

function NWGetPreferredConnName (
	preferredName: Pbyte;
	preferredType: Pbyte): word;
	
function NWFreeConnectionSlot (
	connID: word;
	disconnectType: byte): word;
	
function NWGetNextConnectionID (
	connID: Pword): word;

implementation

{File NWNET.IDX:}
{function WEP     ; external 'nwnet' index 0419;}
function NWDSGETOBJECTHOSTSERVERADDRESS; external 'nwnet' index  1127;
{function _NWFREECONNECTIONSLOT; external 'nwnet' index  2032;}
function NWDSLOGINASCONTAINERAUDITOR; external 'nwnet' index  3040;
function NWDSPUTCHANGE; external 'nwnet' index  1016;
function NWREADAUDITINGBITMAP; external 'nwnet' index  3017;
function NWGETNUMCONNECTIONS; external 'nwnet' index  2003;
function NWCHECKAUDITACCESS; external 'nwnet' index  3003;
function NWDSJOINPARTITIONS; external 'nwnet' index  1063;
function NWDSGETCONTAINERAUDITSTATS; external 'nwnet' index  3039;
{function _NWDSGETCONNECTIONSLOT; external 'nwnet' index  2030;}
function NWDSGETATTRNAME; external 'nwnet' index  1013;
function NWREADAUDITCONFIGHEADER; external 'nwnet' index  3016;
function NWDSREMOVEALLTYPES; external 'nwnet' index  1057;
function NWDSADDOBJECT; external 'nwnet' index  1024;
function NWSETDEFAULTNAMECONTEXT; external 'nwnet' index  2011;
function NWDSSPLITPARTITION; external 'nwnet' index  1067;
function NWDSGETCONTEXT; external 'nwnet' index  1003;
function NWDSREMOVEREPLICA; external 'nwnet' index  1065;
function NWGETPREFERREDCONNNAME; external 'nwnet' index  2031;
procedure NWGETNWNETVERSION; external 'nwnet' index  1129;
{function NWDSDELFILTERTOKEN; external 'nwnet' index  1069;}
function NWENABLEAUDITINGONVOLUME; external 'nwnet' index  3008;
function NWADDAUDITPROPERTY; external 'nwnet' index  3001;
function NWDSGETAUDITINGFLAGS; external 'nwnet' index  3038;
function NWDSCHECKAUDITACCESS; external 'nwnet' index  3032;
function NWDSREADSYNTAXES; external 'nwnet' index  1090;
function NWDSFREECONTEXT; external 'nwnet' index  1002;
function NWDSCHANGEAUDITORPASSWORD; external 'nwnet' index  3031;
function NWDSGETSYNTAXID; external 'nwnet' index  1055;
function NWGETNEXTCONNECTIONID; external 'nwnet' index  2009;
function NWDSREADREFERENCES; external 'nwnet' index  1150;
function NWDSABBREVIATENAME; external 'nwnet' index  1054;
function NWDSREADOBJECTINFO; external 'nwnet' index  1029;
function NWDSSETCONTEXT; external 'nwnet' index  1004;
function NWDSDISABLEAUDITINGONCONTAINER; external 'nwnet' index  3036;
function NWDSGETEFFECTIVERIGHTS; external 'nwnet' index  1046;
function NWDSREADCLASSDEF; external 'nwnet' index  1037;
function NWDSLISTCONTAINERS; external 'nwnet' index  1146;
function NWDSREAD; external 'nwnet' index  1028;
function NWDSCLOSEITERATION; external 'nwnet' index  1072;
function NWDSWHOAMI; external 'nwnet' index  1093;
function NWDSREPAIRTIMESTAMPS; external 'nwnet' index  1135;
function NWDSPUTATTRVAL; external 'nwnet' index  1017;
function NWGETFILESERVERUTCTIME; external 'nwnet' index  1138;
function NWDSFREEBUF; external 'nwnet' index  1007;
{function NWDSGETDSVERINFO; external 'nwnet' index  1156;}
function NWDSADDPARTITION; external 'nwnet' index  1060;
function NWRESETAUDITINGFILE; external 'nwnet' index  3021;
function NWDSRESETAUDITHISTORYFILE; external 'nwnet' index  3045;
function NWDSLISTBYCLASSANDNAME; external 'nwnet' index  1141;
function NWDSLOGOUT; external 'nwnet' index  3029;
function NWDSLISTPARTITIONS; external 'nwnet' index  1059;
{function NWDSFREEFILTER; external 'nwnet' index  1040;}
function NWDSGETSERVERNAME; external 'nwnet' index  1085;
function NWISDSAUTHENTICATED; external 'nwnet' index  2008;
function NWDSGETBINDERYCONTEXT; external 'nwnet' index  1134;
function NWDSUNLOCKCONNECTION; external 'nwnet' index  2029;
function NWDSGETSERVERDN; external 'nwnet' index  1130;
function NWDSMAPNAMETOID; external 'nwnet' index  1050;
function NWGETCONNECTIONIDFROMNAME; external 'nwnet' index  2013;
function NWDSGETCLASSITEM; external 'nwnet' index  1020;
function NWDSEXTSYNCSEARCH; external 'nwnet' index  1153;
function NWDSCANONICALIZENAME; external 'nwnet' index  1031;
function NWDSCHANGEREPLICATYPE; external 'nwnet' index  1062;
function NWDSGETPARTITIONROOT; external 'nwnet' index  1058;
function NWDSCOMPARE; external 'nwnet' index  1025;
function NWDSPUTATTRNAME; external 'nwnet' index  1015;
function NWCHECKAUDITLEVELTWOACCESS; external 'nwnet' index  3004;
function NWGETNEARESTDIRECTORYSERVICE; external 'nwnet' index  2007;
function NWDSINITBUF; external 'nwnet' index  1005;
function NWDSLOGIN; external 'nwnet' index  3028;
function NWINITAUDITLEVELTWOPASSWORD; external 'nwnet' index  3012;
function NWDSREMSECURITYEQUIV; external 'nwnet' index  1155;
function NWFREECONNECTIONSLOT; external 'nwnet' index  2005;
function NWISDSSERVER; external 'nwnet' index  1132;
function NWDSVERIFYOBJECTPASSWORD; external 'nwnet' index  3030;
function NWDSISOBJECTBEINGAUDITED; external 'nwnet' index  3047;
function NWGETPREFERREDDSSERVER; external 'nwnet' index  2014;
function NWDSDEFINECLASS; external 'nwnet' index  1033;
function NWCLOSEOLDAUDITINGFILE; external 'nwnet' index  3005;
function NWDSBEGINCLASSITEM; external 'nwnet' index  1071;
function NWDSREADATTRDEF; external 'nwnet' index  1036;
function NWISUSERBEINGAUDITED; external 'nwnet' index  3013;
function NWRESETAUDITHISTORYFILE; external 'nwnet' index  3020;
function NWDSLOGOUTASCONTAINERAUDITOR; external 'nwnet' index  3041;
function NWDSDELETEOLDAUDITINGFILE; external 'nwnet' index  3035;
function NWDSCHANGEOBJECTPASSWORD; external 'nwnet' index  3026;
function NWDSREMOVEPARTITION; external 'nwnet' index  1064;
function NWDSGENERATEOBJECTKEYPAIR; external 'nwnet' index  3027;
{function NWDSPUTFILTER; external 'nwnet' index  1041;}
function NWDSREPLACEATTRNAMEABBREV; external 'nwnet' index  1053;
function NWDSGETSERVERADDRESSES; external 'nwnet' index  1131;
function NWGETVOLUMEAUDITSTATS; external 'nwnet' index  3010;
function NWDSEXTSYNCLIST; external 'nwnet' index  1152;
function NWLOGINASVOLUMEAUDITOR; external 'nwnet' index  3014;
function NWDSLISTCONTAINABLECLASSES; external 'nwnet' index  1034;
function NWDSREADAUDITCONFIGHEADER; external 'nwnet' index  3042;
function NWDSRESETAUDITINGFILE; external 'nwnet' index  3043;
function NWDSGETSYNTAXDEF; external 'nwnet' index  1087;
function NWCHANGEAUDITORPASSWORD; external 'nwnet' index  3002;
function NWDSGETSYNTAXCOUNT; external 'nwnet' index  1086;
function NWDSENABLEAUDITINGONCONTAINER; external 'nwnet' index  3037;
function NWDSSYNCPARTITION; external 'nwnet' index  1148;
function NWINITAUDITFILEREAD; external 'nwnet' index  3011;
function NWDSREMOVECLASSDEF; external 'nwnet' index  1044;
function NWDSMODIFYCLASSDEF; external 'nwnet' index  1035;
function NWREMOVEAUDITPROPERTY; external 'nwnet' index  3019;
function NWDSBACKUPOBJECT; external 'nwnet' index  2034;
function NWDSGETOBJECTNAME; external 'nwnet' index  1014;
function NWDSCHANGEOBJECTAUDITPROPERTY; external 'nwnet' index  3046;
function NWDSPARTITIONRECEIVEALLUPDATES; external 'nwnet' index  1144;
function NWDSREMOVEATTRDEF; external 'nwnet' index  1038;
function NWDSCREATECONTEXT; external 'nwnet' index  1001;
function NWDSGETMONITOREDCONNECTION; external 'nwnet' index  2025;
function NWDSDUPLICATECONTEXT; external 'nwnet' index  1139;
function NWDSCISTRINGSMATCH; external 'nwnet' index  1142;
function NWDSOPENSTREAM; external 'nwnet' index  1056;
function NWDSSEARCH; external 'nwnet' index  1042;
function NWDSPUTCLASSITEM; external 'nwnet' index  1021;
function NWDSGETCLASSDEFCOUNT; external 'nwnet' index  1009;
function NWDSGETCONNECTIONINFO; external 'nwnet' index  2001;
function NWWRITEAUDITCONFIGHEADER; external 'nwnet' index  3022;
function NWDSGETCLASSDEF; external 'nwnet' index  1019;
function NWDSMODIFYDN; external 'nwnet' index  1027;
function NWDSMOVEOBJECT; external 'nwnet' index  1137;
function NWDSCOMPUTEATTRVALSIZE; external 'nwnet' index  1047;
function NWGETDEFAULTNAMECONTEXT; external 'nwnet' index  2010;
function NWDSEXTSYNCREAD; external 'nwnet' index  1151;
function NWDSALLOCFILTER; external 'nwnet' index  1039;
function NWDSPARTITIONSENDALLUPDATES; external 'nwnet' index  1145;
function NWLOGOUTASVOLUMEAUDITOR; external 'nwnet' index  3015;
function NWDSRESOLVENAME; external 'nwnet' index  2033;
function NWDSMAPIDTONAME; external 'nwnet' index  1048;
function NWDSGETCOUNTBYCLASSANDNAME; external 'nwnet' index  1143;
function NWDSCLOSEOLDAUDITINGFILE; external 'nwnet' index  3034;
function NWDSSETMONITOREDCONNECTION; external 'nwnet' index  2026;
function NWWRITEAUDITINGBITMAP; external 'nwnet' index  3023;
function NWDSLOCKCONNECTION; external 'nwnet' index  2028;
{function NWSETPREFERREDDSSERVER; external 'nwnet' index  2015;}
{function NWDSSETCONNECTIONINFO; external 'nwnet' index  2002;}
function NWDSGETATTRDEF; external 'nwnet' index  1018;
function NWDISABLEAUDITINGONVOLUME; external 'nwnet' index  3007;
function NWDSGETOBJECTCOUNT; external 'nwnet' index  1011;
function NWDSAUTHENTICATE; external 'nwnet' index  3025;
function NWDSADDFILTERTOKEN; external 'nwnet' index  1051;
function NWDSADDREPLICA; external 'nwnet' index  1061;
function NWDSABORTPARTITIONOPERATION; external 'nwnet' index  1147;
function NWDSLIST; external 'nwnet' index  1023;
function NWDELETEOLDAUDITINGFILE; external 'nwnet' index  3006;
function NWDSGETCONNECTIONSLOT; external 'nwnet' index  2004;
function NWDSWRITEAUDITCONFIGHEADER; external 'nwnet' index  3044;
function NWDSREADSYNTAXDEF; external 'nwnet' index  1140;
function NWDSGETCLASSITEMCOUNT; external 'nwnet' index  1010;
function NWDSDEFINEATTR; external 'nwnet' index  1032;
function NWDSGETATTRVAL; external 'nwnet' index  1022;
{function NWDSCHANGERESOURCEONCONNECTION; external 'nwnet' index  2024;}
function NWREADAUDITINGFILERECORD; external 'nwnet' index  3018;
function NWSETPREFERREDDSTREE; external 'nwnet' index  2027;
function NWGETCONNECTIONIDFROMADDRESS; external 'nwnet' index  2006;
function NWDSCHECKAUDITLEVELTWOACCESS; external 'nwnet' index  3033;
{function NWCONVERTCONNECTION; external 'nwnet' index  2012;}
function NWDSALLOCBUF; external 'nwnet' index  1006;
function NWDSADDSECURITYEQUIV; external 'nwnet' index  1154;
function NWDSMODIFYRDN; external 'nwnet' index  1136;
function NWGETAUDITINGFLAGS; external 'nwnet' index  3009;
function NWDSREMOVEOBJECT; external 'nwnet' index  1030;
function NWDSMODIFYOBJECT; external 'nwnet' index  1026;
function NWDSAUDITGETOBJECTID; external 'nwnet' index  1094;
function NWDSRESTOREOBJECT; external 'nwnet' index  2035;
function NWDSLISTATTRSEFFECTIVERIGHTS; external 'nwnet' index  1133;
function NWDSINSPECTENTRY; external 'nwnet' index  1149;
function NWDSGETPARTITIONINFO; external 'nwnet' index  1070;
function NWDSGETATTRCOUNT; external 'nwnet' index  1008;

{File NWLOCALE.IDX:}
{function WEP     ; external 'nwlocale' index 03E8;}
{function NWLLOCALECONV; external 'nwlocale' index     1;}
{function NWLSETLOCALE; external 'nwlocale' index     2;}
{function NWCHARTYPE; external 'nwlocale' index     5;}
{function NWCHARVAL; external 'nwlocale' index     6;}
{function NWISALNUM; external 'nwlocale' index     7;}
{function NWISALPHA; external 'nwlocale' index     8;}
{function NWISDIGIT; external 'nwlocale' index     9;}
{function NWLSTRFTIME; external 'nwlocale' index    10;}
{function NWSTRNCOLL; external 'nwlocale' index    15;}
{function NWINCREMENT; external 'nwlocale' index    21;}
{function NWLMBLEN; external 'nwlocale' index    22;}
{function NWSTRIMONEY; external 'nwlocale' index    25;}
{function NWSTRMONEY; external 'nwlocale' index    26;}
{function NWSTRNUM; external 'nwlocale' index    27;}
{function NWATOI  ; external 'nwlocale' index    28;}
{function NWLSTRCHR; external 'nwlocale' index    30;}
{function NWLSTRCSPN; external 'nwlocale' index    31;}
{function NWLSTRREV; external 'nwlocale' index    32;}
{function NWLSTRPBRK; external 'nwlocale' index    33;}
{function NWLSTRRCHR; external 'nwlocale' index    34;}
{function NWLSTRSPN; external 'nwlocale' index    35;}
{function NWLSTRSTR; external 'nwlocale' index    36;}
{function NWSTRNCPY; external 'nwlocale' index    37;}
{function NWLSTRBCPY; external 'nwlocale' index    39;}
{function NWVSPRINTF; external 'nwlocale' index    44;}
{function _NWwsprintf; external 'nwlocale' index    45;}
{function _NWsprintf; external 'nwlocale' index    48;}
function NWLOADRULETABLE; external 'nwlocale' index    51;
function NWUNLOADRULETABLE; external 'nwlocale' index    52;
function NWLOCALTOUNICODE; external 'nwlocale' index    53;
function NWUNICODETOLOCAL; external 'nwlocale' index    54;
function NWUNICODETOCOLLATION; external 'nwlocale' index    55;
function NWUNICODECOMPARE; external 'nwlocale' index    56;
function NWUNICODETOMONOCASE; external 'nwlocale' index    57;
function NWFREEUNICODETABLES; external 'nwlocale' index    58;
function NWGETUNICODETOLOCALHANDLE; external 'nwlocale' index    59;
function NWGETLOCALTOUNICODEHANDLE; external 'nwlocale' index    60;
function NWGETMONOCASEHANDLE; external 'nwlocale' index    61;
function NWGETCOLLATIONHANDLE; external 'nwlocale' index    62;
function NWINITUNICODETABLES; external 'nwlocale' index    63;
function UNICAT  ; external 'nwlocale' index    70;
function UNICHR  ; external 'nwlocale' index    71;
function UNICPY  ; external 'nwlocale' index    72;
function UNICSPN ; external 'nwlocale' index    73;
function UNILEN  ; external 'nwlocale' index    74;
function UNINCAT ; external 'nwlocale' index    75;
function UNINCPY ; external 'nwlocale' index    76;
function UNINSET ; external 'nwlocale' index    77;
function UNIPBRK ; external 'nwlocale' index    78;
function UNIPCPY ; external 'nwlocale' index    79;
function UNIRCHR ; external 'nwlocale' index    80;
function UNIREV  ; external 'nwlocale' index    81;
function UNISET  ; external 'nwlocale' index    82;
function UNISPN  ; external 'nwlocale' index    83;
function UNISTR  ; external 'nwlocale' index    84;
function UNITOK  ; external 'nwlocale' index    85;
function UNIICMP ; external 'nwlocale' index    86;
function UNINICMP; external 'nwlocale' index    87;
function UNISIZE ; external 'nwlocale' index    88;
{function NWGETNWLOCALEVERSION; external 'nwlocale' index   100;}
{function _ReorderPrintfParameters; external 'nwlocale' index   101;}

end.
